--*******1*********2*********3*********4*********5*********6*********7*****
package ANSI_ESC is
---------------------------------------------------------------------------
-- Ein "ANSI-Bildschirm" ist ein zeichenorientierter Bildschirm, der
-- zusammen mit seinem Treiber der ANSI-Norm 3.64-1974 entspricht. Das
-- Paket ANSI_ESC stellt Prozeduren zur Verfuegung, mit denen man die
-- Attribute eines ANSI-Bildschirms (Farbe der Schrift, Farbe des Hinter-
-- grunds, fett, blinkend, Cursorposition etc.) beeinflussen kann. Der
-- Bildschirm muss die aktuelle Ausgabedatei sein (zu der z.B. ein Befehl
-- wie text_io.put("Hallo!") ausgibt). Umlenkungen sind nicht moeglich.
---------------------------------------------------------------------------
   -- Fuer die Prozedur GEH_NACH:
   subtype ZEILE  is integer range 1..25;
   subtype SPALTE is integer range 1..80;
   ------------------------------------------------------------------------
   -- Hier alle ANSI-Bildschirmattribute. Viele Bildschirme unterstuetzen
   -- einige, aber nicht alle Attribute (z.B. kennen viele Bildschirme
   -- die Attribute SCHNELL_BLINKEND, SUBSKRIPT und SUPERSKRIPT nicht).
   -- "V_ROT" bedeutet: "Vordergrund rot". Andere FArben entsprechend.
   -- "H_ROT" bedeutet: "Hintergrund rot". Andere Farben entsprechend.
   -- "REVERS" bedeutet: schwarze Schrift auf weissem Hintergrund.
   -- "VERMINDERT" ist das Gegenteil von "FETT".
   -- Das Attribut NEUTRAL kann beliebig oft gesetzt werden. Es veraendert
   -- nichts (wie die 0 beim Addieren oder die 1 beim Multiplizieren).
   type BILDSCHIRM_ATTRIBUT is
   (NORMAL, FETT, VERMINDERT, KURSIV, UNTERSTRICHEN,
    BLINKEND, SCHNELL_BLINKEND, REVERS, UNSICHTBAR,
    V_SCHWARZ, V_ROT, V_GRUEN, V_GELB, V_BLAU, V_VIOLETT, V_KOBALT, V_WEISS,
    H_SCHWARZ, H_ROT, H_GRUEN, H_GELB, H_BLAU, H_VIOLETT, H_KOBALT, H_WEISS,
    SUBSKRIPT, SUPERSKRIPT, NEUTRAL);
   ------------------------------------------------------------------------
   procedure SBA(A1, A2, A3, A4, A5, A6: BILDSCHIRM_ATTRIBUT := NEUTRAL);
   -- Setze Bildschirm-Attribute. Mit dieser Prozedur koennen
   -- pro Aufruf bis zu 6 Attribute gesetzt werden, z.B. so:
   -- SBA(H_ROT, V_GRUEN, BLINKEND);
   -- Nach diesem Aufruf von SBA erscheinen alle Ausgaben zum Bildschirm
   -- gruen auf rot blinkend. Nach dem Aufruf SBA(NORMAL) erscheinen
   -- Ausgaben zum Bildschirm wieder weiss auf schwarz, nicht blinkend.
   ------------------------------------------------------------------------
   procedure GEH_NACH(Y: ZEILE; X: SPALTE);
   -- Bringt den Cursor in die Spalte X der Zeile Y. ZEILE und SPALTE
   -- sind Untertypen des Typs integer (siehe oben in dieser Spezifikation).
   ------------------------------------------------------------------------
   procedure LOESCHE_BILDSCHIRM;
   -- Loescht den Bildschirm.
   ------------------------------------------------------------------------
end ANSI_ESC;
--*******1*********2*********3*********4*********5*********6*********7*****
