with ada.text_io;
procedure BRUCH_02 is
---------------------------------------------------------------------------
-- Zeigt den Umgang mit zwei dezimalen Festpunkttypen (namens DFIX1 und
-- DFIX2) unterschiedlicher Genauigkeit.
---------------------------------------------------------------------------
   type     DFIX1    is delta 0.01   digits 8;
   type     DFIX2    is delta 0.0001 digits 6;
   package  DFIX1_EA is new ada.text_io.decimal_io(num => DFIX1);
   package  DFIX2_EA is new ada.text_io.decimal_io(num => DFIX2);
   A1, B1 : DFIX1;
   A2, B2 : DFIX2;
   ------------------------------------------------------------------------
   procedure PUT(S: string; D: DFIX1) is
   -- Gibt den String S und die Dezimalzahl D zur aktuellen Ausgabe aus
   begin
      ada.text_io.put(item => S);
      DFIX1_EA   .put(item => D);
      ada.text_io.new_line;
   end PUT;
   ------------------------------------------------------------------------
   procedure PUT(S: string; D: DFIX2) is
   -- Gibt den String S und die Dezimalzahl D zur aktuellen Ausgabe aus
      BLANKS : constant string(1..4) := (others => ' ');
   begin
      ada.text_io.put(item => S & BLANKS);
      DFIX2_EA   .put(item => D);
      ada.text_io.new_line;
   end PUT;
   ------------------------------------------------------------------------
begin
   loop
      ada.text_io.put(item => "BRUCH_02: Zwei Bruchzahlen A1 und B2? ");
      DFIX1_EA   .get(item =>  A1);
      DFIX2_EA   .get(item =>  B2);
      A2 := DFIX2(A1);
      B1 := DFIX1(B2);
      PUT(S => "A1    ist gleich ", D =>       A1);
      PUT(S => "A2    ist gleich ", D =>       A2);
      PUT(S => "B1    ist gleich ", D =>       B1);
      PUT(S => "B2    ist gleich ", D =>       B2);   
      PUT(S => "A1+B1 ist gleich ", D =>       A1+B1);
      PUT(S => "A1-B1 ist gleich ", D =>       A1-B1);
      PUT(S => "A1*B2 ist gleich ", D => DFIX1(A1*B2));
      PUT(S => "A1/B2 ist gleich ", D => DFIX1(A1/B2));
      PUT(S => "A2+B2 ist gleich ", D =>       A2+B2);
      PUT(S => "A2-B2 ist gleich ", D =>       A2-B2);
      PUT(S => "A1*B2 ist gleich ", D => DFIX2(A1*B2));
      PUT(S => "A1/B2 ist gleich ", D => DFIX2(A1/B2));
   end loop;
end BRUCH_02;