with ada.text_io;
procedure BRUCH_05 is
---------------------------------------------------------------------------
-- Zeigt den Umgang mit zwei dezimalen Festpunkttypen (namens GFIX1 und
-- GFIX2) unterschiedlicher Genauigkeit.
---------------------------------------------------------------------------
   type    GFIX1    is delta 0.1  range -10_000.0..+10_000.0;
   type    GFIX2    is delta 0.01 range -10_000.0..+10_000.0;
   package GFIX1_EA is new ada.text_io.fixed_io(num => GFIX1);
   package GFIX2_EA is new ada.text_io.fixed_io(num => GFIX2);
   A1, B1 : GFIX1;
   A2, B2 : GFIX2;
   ------------------------------------------------------------------------
   procedure PUT(S: string; F: GFIX1) is
   -- Gibt den String S und die Festpunktzahl F zur aktuellen Ausgabe aus
   begin
      ada.text_io.put(item => S);
      GFIX1_EA    .put(item => F);
      ada.text_io.new_line;
   end PUT;
   ------------------------------------------------------------------------
   procedure PUT(S: string; F: GFIX2) is
   -- Gibt den String S und die Festpunktzahl F zur aktuellen Ausgabe aus
   begin
      ada.text_io.put(item => S);
      GFIX2_EA   .put(item => F);
      ada.text_io.new_line;
   end PUT;
   ------------------------------------------------------------------------
begin
   loop
      ada.text_io.put(item => "BRUCH_05: Zwei Bruchzahlen A1 und B2? ");
      GFIX1_EA.get(item => A1);
      GFIX2_EA.get(item => B2);
      A2 := GFIX2(A1);
      B1 := GFIX1(B2);
      PUT(S => "A1    ist gleich ", F =>       A1);
      PUT(S => "A2    ist gleich ", F =>       A2);
      PUT(S => "B1    ist gleich ", F =>       B1);
      PUT(S => "B2    ist gleich ", F =>       B2);   
      PUT(S => "A1+B1 ist gleich ", F =>       A1+B1);
      PUT(S => "A1-B1 ist gleich ", F =>       A1-B1);
      PUT(S => "A1*B2 ist gleich ", F => GFIX1(A1*B2));
      PUT(S => "A1/B2 ist gleich ", F => GFIX1(A1/B2));
      PUT(S => "A2+B2 ist gleich ", F =>       A2+B2);
      PUT(S => "A2-B2 ist gleich ", F =>       A2-B2);
      PUT(S => "A1*B2 ist gleich ", F => GFIX2(A1*B2));
      PUT(S => "A1/B2 ist gleich ", F => GFIX2(A1/B2));
   end loop;
end BRUCH_05;