with ada.text_io, system;
procedure BRUCH_10 is
---------------------------------------------------------------------------
-- Liest eine Zahl ein, berechnet ihre Fakultaet und gibt das Ergebnis
-- (und einige Zwischenergebnisse) zur aktuellen Ausgabe aus.
-- Dieser Vorgang wird viermal wiederholt. Dabei wird ein Ganzzahltyp,
-- dann ein dezimaler Fixpunkttyp, dann ein gewoehnlicher Fixpunkttyp und
-- schliesslich ein Gleitpunkttyp verwendet.
-- Soll den Unterschied zwischen diesen Typklassen demonstrieren.
---------------------------------------------------------------------------
   type    GANZ     is range 0..system.max_int;
   type    DFIX     is delta 1.0 digits 18;  -- muss evt. angepasst werden!
   type    GFIX     is delta 1.0 range 0.0..2.0**system.max_mantissa;
   type    GLEIT    is digits system.max_digits;
   package GANZ_EA  is new ada.text_io.integer_io(num => GANZ);
   package DFIX_EA  is new ada.text_io.decimal_io(num => DFIX);
   package GFIX_EA  is new ada.text_io.fixed_io  (num => GFIX);
   package GLEIT_EA is new ada.text_io.float_io  (num => GLEIT);
   GANZ_BIS,  GANZ_I,  GANZ_FAK  : GANZ  := 1;
   DFIX_BIS,  DFIX_I,  DFIX_FAK  : DFIX  := 1.0;
   GFIX_BIS,  GFIX_I,  GFIX_FAK  : GFIX  := 1.0;
   GLEIT_BIS, GLEIT_I, GLEIT_FAK : GLEIT := 1.0;
begin
   ------------------------------------------------------------------------
   -- Mit dem Ganzzahltyp GANZ rechnen:
   ada.text_io.put(item => "Eine GANZ-Ganzzahl (2..50)? ");
   GANZ_EA    .get(item => GANZ_BIS);
   GANZ_BLOCK: begin
      loop
         exit when GANZ_BIS-1 < GANZ_I;
         GANZ_I   := GANZ_I + 1;
         GANZ_FAK := GANZ_FAK * GANZ_I;
         GANZ_EA.put(item => GANZ_I);
         GANZ_EA.put(item => GANZ_FAK);
         ada.text_io.new_line;
      end loop;
   exception
      when constraint_error =>
         ada.text_io.put_line(item => "constraint_error im GANZ_BLOCK");
   end GANZ_BLOCK;
   ------------------------------------------------------------------------
   -- Mit dem dezimalen Fixpunkttyp DFIX rechnen:
   ada.text_io.put(item => "Eine DFIX-Bruchzahl (2.0..50.0)? ");
   DFIX_EA    .get(item => DFIX_BIS);
   DFIX_BLOCK: begin
      loop
         exit when DFIX_BIS-1.0 < DFIX_I;
         DFIX_I   := DFIX_I + 1.0;
         DFIX_FAK := DFIX_FAK * DFIX_I;
         DFIX_EA.put(item => DFIX_I);
         DFIX_EA.put(item => DFIX_FAK);
         ada.text_io.new_line;
      end loop;
   exception
      when constraint_error =>
         ada.text_io.put_line(item => "constraint_error im DFIX_BLOCK");
   end DFIX_BLOCK;
   ------------------------------------------------------------------------
   -- Mit dem gewoehnlichen Festpunkttyp GFIX rechnen:
   ada.text_io.put(item => "Eine GFIX-Bruchzahl (2.0..50.0)? ");
   GFIX_EA    .get(item => GFIX_BIS);
   GFIX_BLOCK: begin
      loop
         exit when GFIX_BIS-1.0 < GFIX_I;
         GFIX_I   := GFIX_I + 1.0;
         GFIX_FAK := GFIX_FAK * GFIX_I;
         GFIX_EA.put(item => GFIX_I);
         GFIX_EA.put(item => GFIX_FAK);
         ada.text_io.new_line;
      end loop;
   exception
      when constraint_error =>
         ada.text_io.put_line(item => "constraint_error im GFIX_BLOCK");
   end GFIX_BLOCK;
   ------------------------------------------------------------------------
   -- Mit dem Gleitpunkttyp GLEIT rechnen:
   ada.text_io.put(item => "Eine GLEIT-Bruchzahl (2.0..2_000.0)? ");
   GLEIT_EA    .get(item => GLEIT_BIS);
   GLEIT_BLOCK: begin
      loop
         exit when GLEIT_BIS-1.0 < GLEIT_I;
         GLEIT_I   := GLEIT_I + 1.0;
         GLEIT_FAK := GLEIT_FAK * GLEIT_I;
         GLEIT_EA.put(item => GLEIT_I,   fore => 4, aft => 0, exp => 0);
         GLEIT_EA.put(item => GLEIT_FAK, fore => 2, aft => system.max_digits);
         ada.text_io.new_line;
      end loop;
   exception
      when constraint_error =>
         ada.text_io.put_line(item => "constraint_error im GLEIT_BLOCK");
   end GLEIT_BLOCK;
   ------------------------------------------------------------------------
   ada.text_io.put_line(item => "BRUCH_10: Das war's erstmal!");
end BRUCH_10;
