with ada.text_io;
procedure BRUCH_11 is
---------------------------------------------------------------------------
-- Fuehrt wiederholt zwei Zuweisungen der folgenden Form aus:
-- X1 := Formel1(X1);   und   X2 := Formel2(X2);
-- und gibt die Werte von X1 und X2 und den Quotienten X1 / X2 zur
-- aktuellen Ausgabe aus. Dabei sind Formel1 und Formel2 zwei mathematisch
-- gleichwertige Formeln, die durch einfache Umformungen ineinander ueber-
-- fuehrt werden koennen. Deshalb sollte der Quotient X1 / X2 (bis auf
-- Rundungsfehler) immer gleich 1.0 sein.
---------------------------------------------------------------------------
   type GLEIT is digits 15 range 0.0 .. 5000.0; -- klein, aber genau
   type GANZ  is           range 1   ..  500;   -- zum Zaehlen
   R            : constant GLEIT := 3.0;
   X1           :          GLEIT := 0.01;
   X2           :          GLEIT := 0.01;
   WIE_OFT      :          GANZ;                -- wird eingelesen
   package GLEIT_EA is new ada.text_io.  float_io(num => GLEIT);
   package  GANZ_EA is new ada.text_io.integer_io(num => GANZ);
begin
   ada.text_io.put(item => "Wie oft (1 .. 500) ? ");
   GANZ_EA    .get(item =>  WIE_OFT);
   ------------------------------------------------------------------------
   for I in GANZ range 1 .. WIE_OFT loop
      X1 := (1.0 +  R) * X1  -   R  * X1**2;  -- X := (1+R)X-RX**2
      X2 :=  X2  +  R  * X2  * (1.0 - X2);    -- X :=  X+RX(1-X)
      GANZ_EA .put(item => I);
      GLEIT_EA.put(item => X1,      exp => 0);
      GLEIT_EA.put(item => X2,      exp => 0);
      GLEIT_EA.put(item => X1 / X2, exp => 0, fore => 5);
      ada.text_io.new_line;
   end loop;
   ------------------------------------------------------------------------
end BRUCH_11;
