with ada.text_io;
procedure DARST_01 is
---------------------------------------------------------------------------
-- Die Werte der 'size-Attribute von verschiedenen Ganzzahluntertypen, 
-- Ganzzahlvariablen und Reihungsuntertypen werden zur aktuellen Ausgabe
-- ausgegeben. Das Pragma pack wird auf einige Reihungsuntertypen ange
-- wendet.
---------------------------------------------------------------------------
   type    GANZ0 is       range -2**31..+2**31-1; -- 32 Bit
   subtype GANZ1 is GANZ0 range -2**15..+2**15-1; -- 16 Bit
   subtype GANZ2 is GANZ1 range -2** 7..+2** 7-1; --  8 Bit
   type    GANZ3 is       range    300..307;      -- 16, 9 oder 3 Bit?
   type    GANZ4 is       range    300..307;      -- 16, 9 oder 3 Bit?
   for     GANZ4'size  use 3; -- 3 Bits genuegen!
   GVAR0 : GANZ0 :=   0;
   GVAR1 : GANZ1 :=   1;
   GVAR2 : GANZ2 :=   2;
   GVAR3 : GANZ3 := 303;
   GVAR4 : GANZ4 := 304;
   type    RT_2U is array(1..10) of GANZ2; -- ungepackt
   type    RT_2P is array(1..10) of GANZ2; -- gepackt
   pragma pack(RT_2P);
   type    RT_3U is array(1..10) of GANZ3; -- ungepackt
   type    RT_3P is array(1..10) of GANZ3; -- gepackt
   pragma pack(RT_3P);
   type    RT_4U is array(1..10) of GANZ4; -- ungepackt
   type    RT_4P is array(1..10) of GANZ4; -- gepackt
   pragma pack(RT_4P);
   ------------------------------------------------------------------------
   procedure PUT(S: string; N: natural) is
   -- Gibt S und N in Textform zur aktuellen Ausgabe aus.
      package NATURAL_EA is new ada.text_io.integer_io(num => natural);
   begin
      ada.text_io.put(item => S);
      NATURAL_EA .put(item => N, width => 4);
      ada.text_io.new_line;
   end PUT;
   ------------------------------------------------------------------------
begin
   PUT(S => "GANZ0'size: ", N => GANZ0'size);
   PUT(S => "GANZ1'size: ", N => GANZ1'size);
   PUT(S => "GANZ2'size: ", N => GANZ2'size);
   PUT(S => "GANZ3'size: ", N => GANZ3'size);
   PUT(S => "GANZ4'size: ", N => GANZ4'size);
   PUT(S => "GVAR0'size: ", N => GVAR0'size);
   PUT(S => "GVAR1'size: ", N => GVAR1'size);
   PUT(S => "GVAR2'size: ", N => GVAR2'size);
   PUT(S => "GVAR3'size: ", N => GVAR3'size);
   PUT(S => "GVAR4'size: ", N => GVAR4'size);
   PUT(S => "RT_2U'size: ", N => RT_2U'size);
   PUT(S => "RT_2P'size: ", N => RT_2P'size);
   PUT(S => "RT_3U'size: ", N => RT_3U'size);
   PUT(S => "RT_3P'size: ", N => RT_3P'size);
   PUT(S => "RT_4U'size: ", N => RT_4U'size);
   PUT(S => "RT_4P'size: ", N => RT_4P'size);
   ada.text_io.put_line(item => "DARST_01: Das war's erstmal!");
end DARST_01;
