with ada.text_io;
procedure DARST_03 is
---------------------------------------------------------------------------
-- Liest Ganzzahlen ein, bis der Benutzer eine 0 eingibt, speichert die
-- Zahlen in einer "Bittabelle" namens TAB1 und gibt sie anschliessend
-- zur aktuellen Ausgabe aus. Das Pragma pack bewirkt, dass jede Komponente
-- von TAB1 nur 1 Bit belegt.
---------------------------------------------------------------------------
   type GANZ    is range -1E7..+1E7;       -- 1E7 ist gleich 10 Millionen
   type TABELLE is array(GANZ) of boolean; -- Ca. 20 Millionen Komponenten
   pragma pack(TABELLE);                   -- Pro Komponente nur 1 Bit
   TAB1 : TABELLE := (others => false);    -- Ca. 20 Millionen Komponenten
   G1   : GANZ;                            -- Zum Einlesen von Ganzzahlen
   package GANZ_EA is new ada.text_io.integer_io(num => GANZ);
begin
   ------------------------------------------------------------------------
   -- Zahlen einlesen und in TAB1 speichern:
   loop
      ada.text_io.put("Eine Ganzzahl (-1E7..+1E7) oder 0 zum Beenden: ");
      GANZ_EA.get(item => G1);
   exit when G1 = 0;
      TAB1(G1) := true; -- Die Zahl G1 in TAB1 speichern
   end loop;
   ------------------------------------------------------------------------
   -- Die in TAB1 gespeicherten Zahlen ausgeben:
   ada.text_io.put_line(item => "Sie haben folgende Zahlen eingegeben:");
   for I in GANZ range TAB1'range loop
      if TAB1(I) then          -- Wenn die Zahl I in TAB1 gespeichert wurde
         GANZ_EA    .put(item => I, width => 0);
         ada.text_io.put(item => ' ');
      end if;
   end loop;
   ada.text_io.new_line;
   ada.text_io.put_line(item => "DARST_03: Das war's erstmal!");
end DARST_03;