with ada.text_io;
procedure DARST_04 is
---------------------------------------------------------------------------
-- Zeigt die Wirkung des Pragma pack auf einen Verbundtyp. Luecken (gaps)
-- zwischen den einzelnen Komponenten werden durch pack beseitigt.
---------------------------------------------------------------------------
   type VERBUNDTYP1 is record
      K1: character;
      K2: integer;
      K3: string(1..3);
      K4: float;
   end record;
   type VERBUNDTYP2 is record
      K1: character;
      K2: integer;
      K3: string(1..3);
      K4: float;
   end record;
   pragma pack(VERBUNDTYP2); -- Auf dieses Pragma kommt es an!
   VERBUNDVAR1: VERBUNDTYP1 := ('X', -123, "ABC", 654.321);
   VERBUNDVAR2: VERBUNDTYP2 := ('Y', +123, "DEF", 321.654);
   ------------------------------------------------------------------------
   procedure PUT(S: string; N: natural) is
   -- Gibt S und N in Textform zur aktuellen Ausgabe aus:
      package NATURAL_EA is new ada.text_io.integer_io(num => natural);
   begin
      ada.text_io.put(item => S);
      NATURAL_EA .put(item => N, width => 4);
      ada.text_io.new_line;
   end PUT;
   ------------------------------------------------------------------------
begin
   PUT(S => "VERBUNDTYP1'size:    ", N => VERBUNDTYP1'size);
   PUT(S => "VERBUNDTYP2'size:    ", N => VERBUNDTYP2'size);
   PUT(S => "VERBUNDVAR1'size:    ", N => VERBUNDVAR1'size);
   PUT(S => "VERBUNDVAR2'size:    ", N => VERBUNDVAR2'size);
   PUT(S => "Pro Variable gespart ", N => VERBUNDVAR1'size - 
                                          VERBUNDVAR2'size);
end DARST_04;