with ada.text_io, system.storage_elements;
procedure DARST_06 is
---------------------------------------------------------------------------
-- Gibt den Inhalt bestimmter Adressen zur aktuellen Ausgabe aus.
-- Bei einem Intel 486- oder 586-Prozessor besteht eine virtuelle Adresse
-- aus einem Selektor (16 Bit) und einem Offset (16 Bit). Z.B. besteht die
-- Adresse 16#1_FFF0# aus dem Selektor 1 und dem Offset FFF0.
-- Achtung: Der Gnat-Compiler 3.10 haelt den Typ
-- system.storage_elements.integer_address fuer eine modularen Typ.
-- Der Aonix-Compiler 7.0 haelt den gleichen Typ fuer einen signierten
-- Ganzzahltyp. Im ARM steht leider nicht, wer Recht hat.
---------------------------------------------------------------------------
   package SSE renames system.storage_elements;
   package TIO renames ada.text_io;
   
   type MODU is mod 2**32;
   M1:  MODU;
   M2:  MODU;
   M3:  MODU;
   M4:  MODU;
   
   ADR1: SSE.integer_address := 16#1_FFF0#;
   ADR2: SSE.integer_address := 16#2_0000#;
   ADR3: SSE.integer_address := 16#3_00A0#;
   ADR4: SSE.integer_address := 16#4_0008#;

   for M1'address use SSE.to_address(ADR1);
   for M2'address use SSE.to_address(ADR2);
   for M3'address use SSE.to_address(ADR3);
   for M4'address use SSE.to_address(ADR4);
   ------------------------------------------------------------------------
   procedure PUT(A: SSE.integer_address; M: MODU) is
   -- Gibt A und M in Textform zur aktuellen Ausgabe aus:
      package SADR_EA is new TIO.modular_io(SSE.integer_address); -- Gnat
   -- package SADR_EA is new TIO.integer_io(SSE.integer_address); -- Aonix
      package MODU_EA is new TIO.modular_io(MODU);
   begin
      TIO    .put(item => "Adresse: ");
      SADR_EA.put(item => A, base => 16);
      TIO    .put(item => "  Inhalt: ");
      MODU_EA.put(item => M, base => 16);
      TIO.new_line;
   end PUT;
   ------------------------------------------------------------------------
begin
   PUT(A => ADR1, M => M1);
   PUT(A => ADR2, M => M2);
   PUT(A => ADR3, M => M3);
   PUT(A => ADR4, M => M4);
end DARST_06;
