with ada.text_io, ada.unchecked_conversion;
procedure DARST_07 is
---------------------------------------------------------------------------
-- Werte eines Typs !GANZ werden (mit einer Instanz der Funktionsschablone
-- ada.unchecked_conversion) in Bittabellen vom Typ !BIT_TAB umgewandelt.
-- Mit der Prozedur PUT_BIN werden mehrere GANZ-Werte als Dezimalzahl und
-- als Bittabelle zur aktuellen Ausgabe ausgegeben.
---------------------------------------------------------------------------
   type GANZ    is range -2e9..+2e9;
   type BIT_TAB is array(positive range 1..GANZ'size) of boolean;
   pragma pack(BIT_TAB);
   
   function GANZ_TO_BIT_TAB is new ada.unchecked_conversion
      (source => GANZ, target => BIT_TAB);
   
   package GANZ_EA is new ada.text_io.integer_io(num => GANZ);
   ------------------------------------------------------------------------
   procedure PUT_BIT_TAB(ITEM: BIT_TAB) is
   -- Gibt die Bittabelle ITEM in lesbarer Form zur aktuellen Ausgabe aus:
      BLANK: constant character := ' ';
   begin
      for I in reverse positive range ITEM'range loop
         if I mod 4 = 0 then                -- Gruppen von je vier
            ada.text_io.put(item => BLANK); -- Bits durch ein Blank
         end if;                            -- voneinander trennen.

         if ITEM(I) then
            ada.text_io.put(item => '1');
         else
            ada.text_io.put(item => '0');
         end if;
      end loop;
      ada.text_io.new_line;
   end PUT_BIT_TAB;
   ------------------------------------------------------------------------
   procedure PUT_BIN(ITEM: GANZ) is
   -- Gibt ITEM als Dezimalzahl und als Bittabelle zur aktuellen Ausgabe
   -- aus:
      BTAB:  constant BIT_TAB   := GANZ_TO_BIT_TAB(ITEM);
      BLANK: constant character := ' ';
   begin
      GANZ_EA    .put(item => ITEM);
      ada.text_io.put(item => BLANK);
      PUT_BIT_TAB    (ITEM => BTAB);
   end PUT_BIN;
   ------------------------------------------------------------------------
   GANZ1: GANZ;
begin
   PUT_BIN(ITEM =>    0);
   PUT_BIN(ITEM =>   +1);
   PUT_BIN(ITEM =>   -1);
   PUT_BIN(ITEM =>  +26);
   PUT_BIN(ITEM =>  -26);
   PUT_BIN(ITEM => +263);
   PUT_BIN(ITEM => -263);
   loop
      ada.text_io.put("Eine Ganzzahl (-2e9..+2e9) oder 0 zum Beenden: ");
      GANZ_EA.get(item => GANZ1);
   exit when GANZ1 = 0;
      PUT_BIN(ITEM => GANZ1);
   end loop;
   ada.text_io.put_line(item => "DARST_07: Das war's erstmal!");
end DARST_07;