with ada.text_io, ada.direct_io;
use  ada.text_io;
procedure EADIR_01 is
---------------------------------------------------------------------------
-- Schreibt die Komponenten der Reihung TAB1 in eine Direktdatei (jede
-- Komponente in einen Satz). Liest alle Saetze der Direktdatei sequentiell
-- und gibt sie zur aktuellen Ausgabe aus. Liest dann wiederholt eine
-- Satz-Nr. von der aktuellen Eingabe, liest den entsprechenden Satz aus
-- der Direktdatei und gibt ihn zur aktuellen Ausgabe aus (bis der Benutzer
-- als Satz-Nr. 0 eingibt). Die Direktdatei wird beim Schliessen auto-
-- matisch geloescht (weil sie einen "leeren Namen" hat).
---------------------------------------------------------------------------
   subtype  STRING10  is string(1..10); -- U.typ der Komponenten und Saetze
   package  DIREKT_EA is new ada.direct_io(element_type => STRING10);
   use type DIREKT_EA.count;            -- Damit Infixnotation moeglich ist
   package  COUNT_EA  is new ada.text_io.integer_io(num => DIREKT_EA.count);

   TAB1 :   array(DIREKT_EA.count range 1..10) of STRING10 :=
    ("Kartoffeln", "Mohrrueben", "Kohlrabi  ", "Gurken    ", "Tomaten   ",
     "Kirschen  ", "Orangen   ", "Aepfel    ", "Birnen    ", "Quitten   ");
   ------------------------------------------------------------------------
   AUSWEIS1: DIREKT_EA.file_type;
   SATZ_NR : DIREKT_EA.count range 0..TAB1'last;
   EIN_TXT : STRING10; -- Zum Einlesen von Saetzen aus der Direktdatei
   ------------------------------------------------------------------------
begin
   -- Die Direktdatei erzeugen und mit Daten fuellen:
   DIREKT_EA.create(file => AUSWEIS1,             -- Wie immer.
                    mode => DIREKT_EA.inout_file, -- Nur bei Direktdateien!
                    name=> "");                   -- Leerer Name!
   for I in DIREKT_EA.count range TAB1'range loop
      DIREKT_EA.write(item=> TAB1(I), file=> AUSWEIS1);
   end loop;
   ------------------------------------------------------------------------
   -- Alle Saetze der Direktdatei sequentiell lesen und ausgeben:
   DIREKT_EA.reset(file => AUSWEIS1);
   while not DIREKT_EA.end_of_file(file => AUSWEIS1) loop
      SATZ_NR := DIREKT_EA.index  (file => AUSWEIS1);
      DIREKT_EA.read(item => EIN_TXT, file => AUSWEIS1);
      put           (item => "Satz-Nr.: ");
      COUNT_EA.put  (item => SATZ_NR, width => 2);
      put_line      (item => " Text: " & EIN_TXT);
   end loop;
   ------------------------------------------------------------------------
   -- Auf einzelne Saetze der Direktdatei direkt zugreifen und ausgeben:
   loop -- bis der Benutzer nicht mehr mag und eine 0 eingibt.
      put           (item => "Eine Ganzzahl 1..10 (0 zum Beenden) ? ");
      COUNT_EA.get  (item => SATZ_NR);
   exit when SATZ_NR = 0; -- Dafuer ist "use type DIREKT_EA.count" noetig!
      DIREKT_EA.read(item =>  EIN_TXT, from => SATZ_NR, file => AUSWEIS1);
      put           (item => "Satz Nr.: ");
      COUNT_EA.put  (item =>  SATZ_NR, width => 2);
      put_line      (item => " Text: " & EIN_TXT);
   end loop;
   ------------------------------------------------------------------------
   DIREKT_EA.close(file => AUSWEIS1);
   put_line(item => "EADIR_01: Das war's erstmal!");
end EADIR_01;
