with ada.text_io, ada.sequential_io;
procedure EASEQ_03 is
---------------------------------------------------------------------------
-- Werte eines varianten Verbundtyps werden in eine sequentielle Datei
-- geschrieben, von dort wieder eingelesen und zur aktuellen Ausgabe
-- ausgegeben.
---------------------------------------------------------------------------
   type VERBUND(MIT_ZUSATZ: boolean := false) is record
      TEXT: string(1..4) := "Leer";
      case MIT_ZUSATZ is
         when true =>
            ZUSATZ: natural := 0;
         when false =>
            null;
      end case;
   end record;
   package VERBUND_SEA is new ada.sequential_io(element_type => VERBUND);
   AUSWEIS1 : VERBUND_SEA.file_type;
   V1 : VERBUND := (MIT_ZUSATZ => true,  TEXT => "XXXX", ZUSATZ => 123);
   V2 : VERBUND := (MIT_ZUSATZ => false, TEXT => "YYYY");
   V3 : VERBUND := (MIT_ZUSATZ => true,  TEXT => "ZZZZ", ZUSATZ => 456);
   V4 : VERBUND;
   B  : constant character := ' ';
begin
   ------------------------------------------------------------------------
   -- Drei Verbunde in die Datei schreiben:
   VERBUND_SEA.create(file => AUSWEIS1, name => "EASEQ_03.AUS");
   VERBUND_SEA.write(item => V1, file => AUSWEIS1);
   VERBUND_SEA.write(item => V2, file => AUSWEIS1);
   VERBUND_SEA.write(item => V3, file => AUSWEIS1);
   ------------------------------------------------------------------------
   -- Aus der Datei lesen und zur aktuellen Ausgabe ausgeben:
   VERBUND_SEA.reset(file => AUSWEIS1, mode => VERBUND_SEA.in_file);
   while not VERBUND_SEA.end_of_file(file => AUSWEIS1) loop
      VERBUND_SEA.read(item => V4, file => AUSWEIS1);
      ada.text_io.put(item => boolean'image(V4.MIT_ZUSATZ) & B);
      ada.text_io.put(item => V4.TEXT & B);
      if V4.MIT_ZUSATZ then
         ada.text_io.put(item => natural'image(V4.ZUSATZ));
      end if;
      ada.text_io.new_line;
   end loop;
   ------------------------------------------------------------------------
   VERBUND_SEA.close(file => AUSWEIS1);
end EASEQ_03;