with ada.streams;
package EAS_A_01 is
---------------------------------------------------------------------------
-- Stellt seinen Benutzern einen Stromtyp (stream type) namens SCHLANGE und
-- die beiden dazugehoehrenden Prozeduren WRITE und READ zur Verfuegung.
-- Ein SCHLANGE-Objekt ist ein FIFO-Speicher (first in, first out).
---------------------------------------------------------------------------
   package AST renames ada.streams;
   type SCHLANGE is new AST.root_stream_type with private;
   procedure WRITE(STROM:    in out SCHLANGE;
                   ELEMENTE: in     AST.stream_element_array);
   -- Schreibt die ELEMENTE in den STROM.
   procedure READ (STROM:    in out SCHLANGE;
                   ELEMENTE:    out AST.stream_element_array;
                   LETZTER_I:   out AST.stream_element_offset);
   -- Holt soviele Stromelemente aus dem STROM, wie in die Reihung ELEMENTE
   -- passen.
private
   type SCHLANGE is new AST.root_stream_type with record
      SPEICHER: AST.stream_element_array(1..1_000);
      LW      : AST.stream_element_offset := 0; -- last written
      LR      : AST.stream_element_offset := 0; -- last read
   end record;
   -- SPEICHER(LW) ist die letzte durch WRITE "gefuellte" Komponente
   -- SPEICHER(LR) ist die letzte durch READ  "geleerte"  Komponente
end EAS_A_01;