with ada.text_io, EAS_A_01;
procedure EAS_A_06 is
---------------------------------------------------------------------------
-- Schreibt Werte verschiedener Typen in einen Strom (stream) namens
-- STROM1, liest sie von dort wieder ein und gibt sie zur aktuellen Ausgabe
-- aus. Dabei werden einige Werte "typenmaessig falsch interpretiert"!
---------------------------------------------------------------------------
   package TIO renames ada.text_io;
   STROM1: aliased EAS_A_01.SCHLANGE;
   type    BLAU    is mod    2**32;   -- 32 Bit modulare Ganzzahlen
   type    GELB    is digits 6;       -- 32 Bit Gleitpunktzahlen
   package BLAU_EA is new ada.text_io.modular_io(num => BLAU);
   package GELB_EA is new ada.text_io.float_io  (num => GELB);
   BLAU1 : BLAU := 1;
   GELB1 : GELB := 1.0;
   GELB2 : GELB := 1.0;
   BLAU2 : BLAU := 1;
begin
   ------------------------------------------------------------------
   -- Ein paar Werte verschiedener Tpen (!BLAU und !GELB) werden in
   -- den STROM1 geschrieben:
   BLAU'output(STROM1'access, BLAU1);
   GELB'output(STROM1'access, GELB1);
   GELB'output(STROM1'access, GELB2);
   BLAU'output(STROM1'access, BLAU2);
   ------------------------------------------------------------------
   -- Aus dem STROM1 werden alle Werte gelesen (die letzten beiden
   -- in falscher Reihenfolge) und zur aktuellen Ausgabe ausgegeben:
   BLAU_EA.put(item => BLAU'input(STROM1'access), width=>0); TIO.new_line;
   GELB_EA.put(item => GELB'input(STROM1'access), exp  =>0); TIO.new_line;
   BLAU_EA.put(item => BLAU'input(STROM1'access), width=>0); TIO.new_line;
   GELB_EA.put(item => GELB'input(STROM1'access), exp  =>0); TIO.new_line;
end EAS_A_06;
