with ada.text_io, ada.streams.stream_io;
procedure EAS_B_02 is
---------------------------------------------------------------------------
-- Schreibt Strings unterschiedlicher Laenge in eine Stromdatei, liest sie
-- von dort wieder ein und gibt sie zur aktuellen Ausgabe aus. Dies
-- geschieht zweimal: einmal mit string'write/string'read und dann nochmal
-- mit string'output/string'input.
---------------------------------------------------------------------------
   package   TIO renames ada.text_io;
   package   SIO renames ada.streams.stream_io;
   AUSWEIS1: SIO.file_type;
   STROM1_Z: SIO.stream_access;
   T1      : string := "Vom Eise befreit sind Strom und Baeche";
   T2      : string := "Durch des Fruehlings holden, belebenden Blick;";
   T3      : string := "Im Tale gruenet Hoffnungsglueck.";
   S29     : string(1..29); -- Zum Einlesen mit der Prozedur string'read
begin
   ------------------------------------------------------------------
   -- Eine neue, leere Stromdatei wird erzeugt. Dem Zeiger STROM1_Z
   -- wird ein Wert zugewiesen, so dass er auf diese Datei zeigt.
   SIO.create(file => AUSWEIS1, name => "EAS_B_02.AUS");
   STROM1_Z := SIO.stream(file => AUSWEIS1);
   ------------------------------------------------------------------
   -- Zwei mal drei Strings werden in die Stromdatei geschrieben:
   string'write (STROM1_Z, T1); -- Einmal      mit string'write
   string'write (STROM1_Z, T2); 
   string'write (STROM1_Z, T3);
   string'output(STROM1_Z, T1); -- und nochmal mit string'output
   string'output(STROM1_Z, T2); 
   string'output(STROM1_Z, T3);
   ------------------------------------------------------------------
   -- Aus der Stromdatei werden mit der Prozedur string'read vier 
   -- Strings der Laenge 29 gelesen und zur akt. Ausgabe ausgegeben:
   SIO.reset(file => AUSWEIS1, mode => SIO.in_file);
   for I in 1..4 loop
      string'read(STROM1_Z, S29);
      TIO.put_line(item =>  S29);
   end loop;
   TIO.new_line;
   ------------------------------------------------------------------
   -- Aus der Stromdatei werden mit der Funktion string'input die drei
   -- uebrigen Strings gelesen und zur aktuellen Ausgabe ausgegeben:
   while not SIO.end_of_file(file => AUSWEIS1) loop
      TIO.put_line(item => string'input(STROM1_Z));
   end loop;
   ------------------------------------------------------------------
   SIO.close(file => AUSWEIS1);
end EAS_B_02;
   