with ada.text_io, ada.streams.stream_io;
procedure EAS_B_03 is
---------------------------------------------------------------------------
-- Schreibt Werte verschiedener Typen in eine Stromdatei, liest sie von
-- dort wieder ein und gibt sie zur aktuellen Ausgabe aus.
---------------------------------------------------------------------------
   package   TIO renames ada.text_io;
   package   SIO renames ada.streams.stream_io;
   AUSWEIS1: SIO.file_type;
   STROM1_Z: SIO.stream_access;
   type    BETRAG is delta 0.01 digits 8;
   package BEA    is new TIO.decimal_io(num => BETRAG);
   T1 : string := "Kartoffeln";
   T2 : string := "Mohrrueben";
   T3 : string := " DM pro Kilo";
   B1 : BETRAG := 1.87;
   B2 : BETRAG := 3.50;
begin
   ------------------------------------------------------------------
   -- Eine neue, leere Stromdatei wird erzeugt. Dem Zeiger STROM1_Z
   -- wird ein Wert zugewiesen, so dass er auf diese Datei zeigt.
   SIO.create(file => AUSWEIS1, name => "EAS_B_03.AUS");
   STROM1_Z := SIO.stream(file => AUSWEIS1);
   ------------------------------------------------------------------
   -- Ein paar Werte verschiedener Typen (!string und !BETRAG) werden 
   -- in die Stromdatei geschrieben:
   string'output(STROM1_Z, T1);
   BETRAG'output(STROM1_Z, B1);
   string'output(STROM1_Z, T3);
   string'output(STROM1_Z, T2);
   BETRAG'output(STROM1_Z, B2);
   string'output(STROM1_Z, T3);
   ------------------------------------------------------------------
   -- Aus der Stromdatei werden alle Werte gelesen und zur aktuellen
   -- Ausgabe ausgegeben:
   SIO.reset(file => AUSWEIS1, mode => SIO.in_file);
   TIO.put(item => string'input(STROM1_Z));
   BEA.put(item => BETRAG'input(STROM1_Z));
   TIO.put(item => string'input(STROM1_Z));
   TIO.new_line;
   TIO.put(item => string'input(STROM1_Z));
   BEA.put(item => BETRAG'input(STROM1_Z));
   TIO.put(item => string'input(STROM1_Z));
   TIO.new_line;
   ------------------------------------------------------------------
   SIO.close(file => AUSWEIS1);
end EAS_B_03;