with ada.text_io, ada.streams.stream_io;
procedure EAS_B_06 is
---------------------------------------------------------------------------
-- Schreibt Werte verschiedener Typen in eine Stromdatei, liest sie von
-- dort wieder ein und gibt sie zur aktuellen Ausgabe aus. Dabei werden
-- einige Werte "typenmaessig falsch interpretiert"!
---------------------------------------------------------------------------
   package   TIO renames ada.text_io;
   package   SIO renames ada.streams.stream_io;
   AUSWEIS1: SIO.file_type;
   STROM1_Z: SIO.stream_access;
   type    BLAU    is mod    2**32;   -- 32 Bit modulare Ganzzahlen
   type    GELB    is digits 6;       -- 32 Bit Gleitpunktzahlen
   package BLAU_EA is new ada.text_io.modular_io(num => BLAU);
   package GELB_EA is new ada.text_io.float_io  (num => GELB);
   BLAU1 : BLAU := 1;
   GELB1 : GELB := 1.0;
   GELB2 : GELB := 1.0;
   BLAU2 : BLAU := 1;
begin
   ------------------------------------------------------------------
   -- Eine neue, leere Stromdatei wird erzeugt. Dem Zeiger STROM1_Z
   -- wird ein Wert zugewiesen, so dass er auf diese Datei zeigt.
   SIO.create(file => AUSWEIS1, name => "EAS_B_03.AUS");
   STROM1_Z := SIO.stream(file => AUSWEIS1);
   ------------------------------------------------------------------
   -- Ein paar Werte verschiedener Tpen (!BLAU und !GELB) werden in
   -- die Stromdatei geschrieben:
   BLAU'output(STROM1_Z, BLAU1);
   GELB'output(STROM1_Z, GELB1);
   GELB'output(STROM1_Z, GELB2);
   BLAU'output(STROM1_Z, BLAU2);
   ------------------------------------------------------------------
   -- Aus der Stromdatei werden alle Werte gelesen (die letzten beiden
   -- in falscher Reihenfolge) und zur aktuellen Ausgabe ausgegeben:
   SIO.reset(file => AUSWEIS1, mode => SIO.in_file);
   BLAU_EA.put(item => BLAU'input(STROM1_Z), width=>0); TIO.new_line;
   GELB_EA.put(item => GELB'input(STROM1_Z), exp  =>0); TIO.new_line;
   BLAU_EA.put(item => BLAU'input(STROM1_Z), width=>0); TIO.new_line;
   GELB_EA.put(item => GELB'input(STROM1_Z), exp  =>0); TIO.new_line;
   ------------------------------------------------------------------
   SIO.close(file => AUSWEIS1);
end EAS_B_06;
