with ada.text_io;
procedure EATXT_01 is
---------------------------------------------------------------------------
-- Demonstriert einfache Ein-/Ausgabe in Textform. In eine Datei namens
-- EATXT_01.AUS werden ein paar Zeilen hineingeschrieben. Dann werden
-- alle Zeilen dieser Datei gelesen und zur aktuellen Ausgbe ausgegeben.
---------------------------------------------------------------------------
   AUSWEIS1: ada.text_io.file_type;
   DAT_NAM : constant string := "EATXT_01.AUS";
   EIN     : string(1..100);                 -- Eingabepuffer
   LBI     : natural;                        -- Letzter belegter Index
   type    FARBE     is (ROT, GRUEN, BLAU);  -- Ein Aufzaehlungstyp
   type    BETRAG    is delta 0.01 digits 8; -- Ein dezimaler Festpunkttyp
   package FARBE_EA  is new ada.text_io.enumeration_io(enum => FARBE);
   package BETRAG_EA is new ada.text_io.decimal_io    ( num => BETRAG);
begin
   ------------------------------------------------------------------
   -- Eine neue leere Datei erzeugen:
   ada.text_io.create(file => AUSWEIS1,
                      mode => ada.text_io.out_file,
                      name => DAT_NAM);
   ------------------------------------------------------------------
   -- Zwei Zeilen in die Datei schreiben:
   ada.text_io.put(item => "Eine Farbe: ", file => AUSWEIS1);
   FARBE_EA   .put(item =>  GRUEN,         file => AUSWEIS1);
   ada.text_io.new_line(                   file => AUSWEIS1);
   ada.text_io.put(item => "Ein Betrag: ", file => AUSWEIS1);
   BETRAG_EA  .put(item =>  123_456.78,    file => AUSWEIS1);
   ada.text_io.new_line(                   file => AUSWEIS1);
   ------------------------------------------------------------------
   -- Alle Zeilen der Datei lesen und zur aktuellen Ausgabe ausgeben:
   ada.text_io.reset(mode => ada.text_io.in_file, file => AUSWEIS1);
   while not ada.text_io.end_of_file(file => AUSWEIS1) loop
      ada.text_io.get_line(item => EIN, last => LBI, file => AUSWEIS1);
      ada.text_io.put_line(item => EIN(EIN'first..LBI));
   end loop;
   ada.text_io.close(file => AUSWEIS1);
   ------------------------------------------------------------------
   if ada.text_io.is_open(file => AUSWEIS1) then
      ada.text_io.put_line(item => "AUSWEIS1 ist noch gueltig!");
   else
      ada.text_io.put_line(item => "AUSWEIS1 ist nicht mehr gueltig!");
   end if;
end EATXT_01;