with ada.text_io;
procedure GANZT_03 is
---------------------------------------------------------------------------
-- Macht nichts sinnvolles. Demonstriert nur, wie man signierte Ganzzahl-
-- typen und Untertypen vereinbart und welche Ausdruecke dann garantiert
-- keinen, moeglicherweise einen oder garantiert einen constraint_error
-- ausloesen.
---------------------------------------------------------------------------
   type AEPFEL   is range 0..30_000;
   type BIRNEN   is range 0..30_000;
   A1, A2 : AEPFEL := 0;
   B1, B2 : BIRNEN := 0;
   type ZITRONEN is range 0..40_000;
   Z1 : ZITRONEN   := 25_000;
   Z2 : ZITRONEN   := 35_000;
   A3 : AEPFEL     := AEPFEL(Z1); -- Ist o.k.
   A4 : AEPFEL     := AEPFEL(Z2); -- Loest constraint_error aus!!
   subtype AEPFEL_PRO_WOCHE is AEPFEL           range 0..70;
   subtype AEPFEL_PRO_TAG   is AEPFEL_PRO_WOCHE range 0..10;  -- Entweder so
   subtype BIRNEN_PRO_WOCHE is BIRNEN           range 0..70;
   subtype BIRNEN_PRO_TAG   is BIRNEN           range 0..10;  -- oder so!
   AW1, AW2 : AEPFEL_PRO_WOCHE := 0;
   AT1, AT2 : AEPFEL_PRO_TAG   := 0;
   BW1, BW2 : BIRNEN_PRO_WOCHE := 0;
   BT1, BT2 : BIRNEN_PRO_TAG   := 0;
   subtype AEPFEL_PRO_STUNDE_1 is AEPFEL_PRO_TAG;               -- erlaubt
   subtype AEPFEL_PRO_STUNDE_2 is AEPFEL_PRO_TAG   range 3..7;  -- erlaubt
   subtype AEPFEL_PRO_STUNDE_3 is AEPFEL_PRO_TAG   range 0..20; -- verboten!!
   subtype AEPFEL_PRO_STUNDE_4 is AEPFEL_PRO_WOCHE range 0..20; -- erlaubt
begin
   -- Die Ausdruecke rechts in den folgenden Zuweisungen
   -- sind typenmaessig korrekt:
   A1 := A1 + AW1 + AT1;
   B1 := B2 * BT1 - BW2;
   B2 := BT1 + 1_000 + BT2;
   -- Folgende Zuweisungen loesen garantiert keine Ausnahme aus
   -- (unabhaengig vom Inhalt der beteiligten Variablen):
   A1  := AW1;
   A1  := 10_000 + Aw1 + AW2 + AT1 + AT2;
   AW1 := 2*AT1 + 3*AT1;
   AT1 := A1 - A1 + AT2;
   -- Folgende Zuweisungen loesen eventuell einen constraint_error aus
   -- (abhaengig vom Inhalt der beteiligten Variablen):
   AT1 := A1 + AW2*AT1 - A2;
   AT1 := AT2;
   A1  := A1 + 1;
   AT1 := A2 + 30_000 - 30_000;
   -- Folgende Zuweisungen loesen garantiert einen constraint_error aus
   -- (unabhaengig vom Inhalt der beteiligten Variablen):
   AT1 := 11;
   A1  := (A1 + 2) * 20_000;
end GANZT_03;
