with ada.text_io;
procedure GANZT_08 is
---------------------------------------------------------------------------
-- Ein Wert eines modularen Ganzzahltyps wird von der aktuellen Eingabe
-- eingelesen und verschiedenen Rechenoperationen (+, -, *) und logischen
-- Verknuepfungen (and, or, xor und not) unterworfen. Die Ergebnisse der
-- Rechnungen und Verknuepfungen werden zur aktuellen Ausgabe ausgegeben.
---------------------------------------------------------------------------
   type    MODU  is mod 2**8; -- Vereinbarung des modularen Ganzzahltyps
   G :     MODU  := 255;      -- Eine Variable, zum Einlesen
   -- Mit den Prozeduren get und put im Paket MODU_EA kann man Werte des
   -- Untertyps MODU einlesen und ausgeben:
   package MODU_EA is new ada.text_io.modular_io(num => MODU);
begin
   -- Einen Wert vom Untertyp MODU nach G einlesen
   ada.text_io.put(item => "Eine Ganzzahl G (0..255)? ");
   MODU_EA.get    (item =>  G);
   -- Auf G verschiedene Rechenoperationen anwenden, Ergebnisse ausgeben:
   ada.text_io.put(item => "G                  ist gleich: ");
   MODU_EA.put    (item =>  G);
   ada.text_io.new_line;
   ada.text_io.put(item => "G + 1              ist gleich: ");
   MODU_EA.put    (item =>  G + 1);
   ada.text_io.new_line;
   ada.text_io.put(item => "G - 1              ist gleich: ");
   MODU_EA.put    (item =>  G - 1);
   ada.text_io.new_line;
   ada.text_io.put(item => "- G                ist gleich: ");
   MODU_EA.put    (item =>  - G);
   ada.text_io.new_line;
   ada.text_io.put(item => "G * 100            ist gleich: ");
   MODU_EA.put    (item =>  G * 100);
   ada.text_io.new_line;
   -- G in binaerer Darstellung ausgeben:
   ada.text_io.put(item => "G (binaer)         ist gleich: ");
   MODU_EA.put    (item =>  G, base => 2, width => 11);
   ada.text_io.new_line;
   -- Auf G verschieden logische Verknuepfungen anwenden und die
   -- Ergebnisse ausgeben:
   ada.text_io.put(item => "G and 2#1111_0000# ist gleich: ");
   MODU_EA.put    (item =>  G and 2#1111_0000#, base => 2, width => 11);
   ada.text_io.new_line;
   ada.text_io.put(item => "G or  2#1111_0000# ist gleich: ");
   MODU_EA.put    (item =>  G or  2#1111_0000#, base => 2, width => 11);
   ada.text_io.new_line;
   ada.text_io.put(item => "G xor 2#1111_0000# ist gleich: ");
   MODU_EA.put    (item =>  G xor 2#1111_0000#, base => 2, width => 11);
   ada.text_io.new_line;
   ada.text_io.put(item => "not G              ist gleich: ");
   MODU_EA.put    (item =>  not G, base => 2, width => 11);
   ada.text_io.new_line;
end GANZT_08;
