with ada.text_io;
procedure GANZT_11 is
---------------------------------------------------------------------------
-- Liest zwei Ganzzahlen G1 und G2 von der aktuellen Eingabe ein und gibt
-- die Werte folgender Ausdruecke zur aktuellen Ausgabe aus:
-- G1 / G2, G1 rem G2, G1 & G2 und G1 mod G2.
-- Dabei ist "&" eine lokal vereinbarte Ganzzahldivisionsoperation, die
-- immer "abrundet" (auch bei negativen Ergebnisse). Die vordefinierte
-- Ganzzahldivision "/" rundet zur 0 (bei negativen Ergebnissen also auf).
---------------------------------------------------------------------------
   type    OTTO    is range -999..+999;
   package OTTO_EA is new ada.text_io.integer_io(num => OTTO);
   G1, G2: OTTO;   -- werden eingelesen.
   package BOOL_EA is new ada.text_io.enumeration_io(enum => boolean);
   -------------------------------------------------------------------
   function "&"(LINKS, RECHTS: OTTO) return OTTO is
   -- Eine Ganzzahldivision, die immer abrundet, auch bei negativen
   -- Ergebnissen, z.B. so:
   -- +7 & +3 ist gleich 2, aber -7 & +3 ist gleich -3
   ---------------------------------------------------
      QUOTIENT            : constant OTTO    := LINKS / RECHTS;
      REST                : constant OTTO    := LINKS mod RECHTS;
      UNGLEICHE_VORZEICHEN: constant boolean :=
         (LINKS < 0) /= (RECHTS < 0);
   begin
      if UNGLEICHE_VORZEICHEN and REST /= 0 then
         return QUOTIENT - 1;
      else
         return QUOTIENT;
      end if;
   end "&";
   -------------------------------------------------------------------
begin
   ada.text_io.put(item => "Zwei Ganzzahlen G1 und G2 (-999..+999): ");
   OTTO_EA.get(item => G1);
   OTTO_EA.get(item => G2);
   ada.text_io.put(item => "                   Dividend G1  ist gleich ");
   OTTO_EA.    put(item =>                              G1);
   ada.text_io.new_line;
   ada.text_io.put(item => "                    Divisor G2  ist gleich ");
   OTTO_EA.    put(item =>                              G2);
   ada.text_io.new_line;
   ada.text_io.put(item => "         /-Quotient (G1  /  G2) ist gleich ");
   OTTO_EA.    put(item =>                       G1  /  G2);
   ada.text_io.new_line;
   ada.text_io.put(item => "           rem-Rest (G1 rem G2) ist gleich ");
   OTTO_EA.    put(item =>                       G1 rem G2);
   ada.text_io.new_line;
   ada.text_io.put(item => "         &-Quotient (G1  &  G2) ist gleich ");
   OTTO_EA.    put(item =>                       G1  &  G2);
   ada.text_io.new_line;
   ada.text_io.put(item => "           mod-Rest (G1 mod G2) ist gleich ");
   OTTO_EA.    put(item =>                       G1 mod G2);
   ada.text_io.new_line;
   ada.text_io.put(item => "(/-Quotient*Divisor + rem-Rest) ist gleich ");
   OTTO_EA.    put(item =>     (G1/G2) *  G2    + G1 rem G2);
   ada.text_io.new_line;
   ada.text_io.put(item => "(&-Quotient*Divisor + mod-Rest) ist gleich ");
   OTTO_EA.    put(item =>     (G1&G2) *  G2    + G1 mod G2);
   ada.text_io.new_line;
   ada.text_io.put(item => "                   Dividend G1  ist gleich ");
   OTTO_EA.    put(item =>                              G1);
   ada.text_io.new_line;
end GANZT_11;
