with ada.unchecked_deallocation, ada.text_io;
package body KON_A_01 is

   procedure GIB_ZURUECK is new ada.unchecked_deallocation
      (object => string, name => Z_STRING);
      -- Diese Prozedur hat einen in-out-Parmeter X vom Typ !Z_STRING.
      -- Das Objekt X.all wird an die Speicherverwaltung zurueckgegeben
      -- und dem Zeiger X wird der Wert null zugewiesen.
      
   procedure PUT(ITEM: ZEICHEN_KETTE; S: string) is
   -- Zum Protokollieren der Aufrufe der Prozduren
   -- INITIALIZE, ADJUST und FINALIZE
      B : constant character := ' '; -- Ein Blank
   begin
      ada.text_io.put(item => B & S & B);
      if ITEM.Z /= null then
         ada.text_io.put(item => ITEM.Z.all);
      else
         ada.text_io.put(item => "Null-Zeiger!");
      end if;
      ada.text_io.new_line;
   end PUT;

   procedure INITIALIZE(ZK: in out ZEICHEN_KETTE) is
   -- Meldet nur, dass sie aufgerufen wurde.
   begin
      PUT(ITEM => ZK, S => "INI ");
   end INITIALIZE;
   
   procedure ADJUST(ZK: in out ZEICHEN_KETTE) is
   -- Kopiert den String ZK.Z.all und laesst den Zeiger ZK.Z
   -- auf die Kopie zeigen.
   begin
      PUT(ITEM => ZK, S => "ADJ1");
      if ZK.Z /= null then
         ZK.Z := new string'(ZK.Z.all);
      end if;
      PUT(ITEM => ZK, S => "ADJ2");
   end ADJUST;

   procedure FINALIZE(ZK: in out ZEICHEN_KETTE) is
   -- Gibt den String ZK.Z.all an die Speicherverwaltung zurueck.
   begin
      PUT(ITEM => ZK, S => "FIN1");
      GIB_ZURUECK(X => ZK.Z);
      PUT(ITEM => ZK, S => "FIN2");
   end FINALIZE;

   procedure MACHE_ZEICHEN_KETTE(S: in string; ZK: in out ZEICHEN_KETTE) is
   -- Konstruktor-Prozedur fuer ZEICHEN_KETTEn
   begin
      PUT(ITEM => ZK, S => "MZK1");
      GIB_ZURUECK(X => ZK.Z);
      ZK.Z := new string'(S);
      PUT(ITEM => ZK, S => "MZK2");
   end MACHE_ZEICHEN_KETTE;

end KON_A_01;
