with ada.unchecked_deallocation, ada.text_io;
package body KON_C_01 is
---------------------------------------------------------------------------
-- Jede ZEICHEN_KETTE-Variable enthaelt einen Zeiger Z, der auf einen
-- String zeigt. In BELEGT steht jeweils, wieviele Bytes all diese Strings
-- zusammen belegen. Die Prozeduren REPORT_ANF und REPORT_END dienen "nur"
-- dazu, die Wirkungsweise dieses Pakets "draussen" sichtbar zu machen.
-- Man kann sie auch entfernen.
---------------------------------------------------------------------------
   type    ANZAHL    is range 0..+2e9;
   package ANZAHL_EA is new ada.text_io.integer_io(num => ANZAHL);
   BELEGT: ANZAHL := 0;

   procedure REPORT_ANF(S: string) is
   begin
      ada.text_io.put(item => S);
      ANZAHL_EA  .put(item => BELEGT);
   end REPORT_ANF; 

   procedure REPORT_END is
   begin
      ANZAHL_EA.put(item => BELEGT);
      ada.text_io.new_line;
   end REPORT_END;
   
   procedure GIB_ZURUECK is new ada.unchecked_deallocation
      (object => string, name => Z_STRING);
   -- Diese Prozedur hat einen in-out-Parmeter X vom Typ !Z_STRING.
   -- Das Objekt X.all wird an die Speicherverwaltung zurueckgegeben
   -- und dem Zeiger X wird der Wert null zugewiesen.

   procedure FINALIZE(ZK: in out ZEICHEN_KETTE) is
   -- Gibt den String ZK.Z.all an die Speicherverwaltung zurueck.
   begin
      REPORT_ANF(S => "FIN: ");
      BELEGT := BELEGT - ZK.Z.all'length;
      GIB_ZURUECK(X => ZK.Z);
      REPORT_END;
   end FINALIZE;
   
   procedure MACHE_ZEICHEN_KETTE(S: in string; ZK: out ZEICHEN_KETTE) is
   -- Konstruktor-Prozedur fuer ZEICHEN_KETTEn
   begin
      REPORT_ANF(S => "MZK: ");
      ZK.Z := new string'(S);
      BELEGT := BELEGT + S'length;
      REPORT_END;
   end MACHE_ZEICHEN_KETTE;
   
   procedure WEISE_ZU(ZIEL: out ZEICHEN_KETTE; QUELLE: in ZEICHEN_KETTE) is
   -- Gibt den String ZIEL.Z.all an die Speicherverwaltung zurueck, kopiert
   -- den String QUELLE.Z.all und laesst den Zeiger ZIEL.Z auf diese Kopie
   -- zeigen.
   begin
      REPORT_ANF(S => "WZU: ");
      BELEGT := BELEGT - ZIEL.Z.all'length;
      GIB_ZURUECK(X => ZIEL.Z);
      ZIEL.Z := new string'(QUELLE.Z.all);
      BELEGT := BELEGT + ZIEL.Z.all'length;
      REPORT_END;
   end WEISE_ZU;

end KON_C_01;
