with ada.unchecked_deallocation, ada.text_io;
package body KON_D_01 is
   package ANZAHL_EA is new ada.text_io.integer_io(num => ANZAHL);
   
   procedure GIB_ZURUECK is new ada.unchecked_deallocation
      (object => string, name => Z_STRING);
   
   procedure GIB_ZURUECK is new ada.unchecked_deallocation
      (object => BLOB, name => Z_BLOB);
      
   procedure REPORT(ZK : ZEICHEN_KETTE; S : string) is
   -- Zum Protokollieren der Aufrufe der Prozeduren MACHE_ZEICHEN_KETTE,
   -- ADJUST und FINALIZE.
      B : constant character := ' ';
   begin
      ada.text_io.put(item => B & S & B);
      if ZK.ZB /= null then  -- Wenn ein BLOB vorhanden
         ada.text_io.put(item => "ZK.ZB.all.AZ:");
         ANZAHL_EA.put  (item => ZK.ZB.all.AZ, width => 3);
         ada.text_io.put(item => B);
         if ZK.ZB.all.ZS /= null then -- Wenn  ein String im BLOB vorhanden
            ada.text_io.put(item => " ZK.ZB.all.ZS.all: ");
            ada.text_io.put(item =>   ZK.ZB.all.ZS.all);
         else                         -- Wenn kein String im Blob vorhanden
            ada.text_io.put(item => "ZK.ZB.all.ZS ist gleich null!");
         end if;
      else                   -- Wenn kein BLOB vorhanden
         ada.text_io.put(item => "ZK.ZB ist gleich null!");
      end if;
      ada.text_io.new_line;
   end REPORT;

   procedure MACHE_ZEICHEN_KETTE(S: string; ZK: in out ZEICHEN_KETTE) is
   -- Macht aus dem String S die ZEICHEN_KETTE ZK
   begin
      REPORT(ZK => ZK, S => "MZK1");
      if ZK.ZB /= null then          -- Wenn ein BLOB vorhanden ist,
         FINALIZE(ZK => ZK);         -- wird er finalisiert ("geloescht").
      end if;
      ZK.ZB        := new BLOB;      -- Einen neuen BLOB erzeugen
      ZK.ZB.all.AZ := 1;             -- 1 Zeiger zeigt auf den neuen BLOB
      ZK.ZB.all.ZS := new string'(S);-- Der neue String wird erzeugt
      REPORT(ZK => ZK, S => "MZK2");
   end MACHE_ZEICHEN_KETTE;
   
   procedure ADJUST  (ZK: in out ZEICHEN_KETTE) is
   -- Erhoeht ZK.ZB.all.AZ (d.h. die Anzahl der Zeiger, die auf den
   -- String ZK.ZB.all.ZS.all zeigen) um 1. 
   begin
      REPORT(ZK => ZK, S => "ADJ1");
      if ZK.ZB /= null then -- Nicht noetig, nur zur Sicherheit.
         ZK.ZB.all.AZ := ZK.ZB.all.AZ + 1;
      end if;
      REPORT(ZK => ZK, S => "ADJ2");
   end ADJUST;
   
   procedure FINALIZE(ZK: in out ZEICHEN_KETTE) is
   -- Wenn ZK.ZB.all.AZ ("die Anzahl der Zeiger die ...") gleich 1 ist,
   -- werden der String ZK.ZB.all.ZS.all und der BLOB ZK.ZB.all
   -- an die Speicherverwaltung zurueckgegeben, sonst wird ZK.ZB.all.AZ
   -- um 1 herabgesetzt.
   begin
      REPORT(ZK => ZK, S => "FIN1");
      if    ZK.ZB = null then
         null;
      elsif ZK.ZB.all.AZ = 1 then
         GIB_ZURUECK(X => ZK.ZB.all.ZS);
         GIB_ZURUECK(X => ZK.ZB);
      else
         ZK.ZB.all.AZ := ZK.ZB.all.AZ - 1;
      end if;
      REPORT(ZK => ZK, S => "FIN2");
   end FINALIZE;
end KON_D_01;
