with ada.finalization;
package KON_D_01 is
---------------------------------------------------------------------------   
-- Stellt einen privaten kontrollierten Typ !ZEICHEN_KETTE und eine
-- Konstruktor-Prozedur MACHE_ZEICHEN_KETTE zur Verfuegung. Objekte
-- ZK1, ZK2, etc. des Typs ZEICHEN_KETTE haben "Referenz-Semantik", d.h.
-- nach einer Zuweisung ZK1 := ZK2 zeigen ZK1 und ZK2 auf denselben String,
-- nicht auf zwei gleich Strings.
---------------------------------------------------------------------------
   type ZEICHEN_KETTE is private;
   procedure MACHE_ZEICHEN_KETTE(S: string; ZK: in out ZEICHEN_KETTE);
private
   type ANZAHL        is range 0..2e9; -- Zum Zaehlen der Zeiger
   type Z_STRING      is access string;
   type BLOB          is record
      AZ : ANZAHL := 0; -- Anzahl Zeiger, die auf diesen BLOB zeigen
      ZS : Z_STRING;
   end record;
   type Z_BLOB        is access BLOB;
   type ZEICHEN_KETTE is new ada.finalization.controlled with record
      ZB: Z_BLOB;
   end record;
   procedure ADJUST  (ZK: in out ZEICHEN_KETTE);
   procedure FINALIZE(ZK: in out ZEICHEN_KETTE);
end KON_D_01;