with ada.text_io;
package PAKET_05 is
---------------------------------------------------------------------------
-- Stellt seinen Benutzern den Aufzaehlungsuntertyp FARBE zur Verfuegung
-- sowie Prozeduren GET und PUT zum Ein- bzw. Ausgeben von FARBE-Werten
-- von der aktuellen Eingabe bzw. zur aktuellen Ausgabe.
-- Damit der Benutzer beim Ausgeben von FARBE-Werten das Ausgabeformat
-- kontrollieren kann (mit den Parametern WIDTH und SET der PUT-Prozedur
-- oder mit den Variablen DEFAULT_WIDTH und DEFAULT_SETTING im Paket
-- FARBE_EA) muessen eine Reihe von Groessen aus den Paketen ada.text_io
-- und FARBE_EA umbenannt werden, um sie draussen sichtbar zu machen.
-- Dieses PAKET_05 stellt seinen Benutzern auch die Prozedur NEW_LINE aus
-- dem Paket ada.text_io per Umbenennung zur Verfuegung. Dabei wird der
-- SPACING-Parameter mit 2 vorbesetzt statt (wie im Original) mit 1.
---------------------------------------------------------------------------
   type    FARBE    is (SCHWARZ, ROT, GRUEN, BLAU, WEISS);
   package FARBE_EA is new ada.text_io.enumeration_io(enum => FARBE);
   ------------------------------------------------------------------------
   -- Umbenennungen von Groessen aus den Paketen ada.text_io und FARBE_EA:
   subtype   FIELD          is ada.text_io.field;
   subtype   TYPE_SET       is ada.text_io.type_set;
   subtype   POSITIVE_COUNT is ada.text_io.positive_count;
   function  LOWER_CASE return TYPE_SET renames ada.text_io.lower_case;
   function  UPPER_CASE return TYPE_SET renames ada.text_io.upper_case;
   DEFAULT_WIDTH      : FIELD      renames FARBE_EA.default_width;
   DEFAULT_SETTING    : TYPE_SET   renames FARBE_EA.default_setting;
   procedure GET(ITEM : out FARBE) renames FARBE_EA.GET;
   procedure PUT(ITEM : in  FARBE;
                 WIDTH: in  FIELD    := DEFAULT_WIDTH;
                 SET  : in  TYPE_SET := DEFAULT_SETTING)
      renames FARBE_EA.PUT;
   procedure NEW_LINE(SPACING: in POSITIVE_COUNT := 2) -- Vorbesetzung 2!
      renames ada.text_io.new_line;
end PAKET_05;