package body PAKET_06 is
   ------------------------------------------------------------------------
   function GGT(Z1, Z2: ZAEHLER_TYP) return NENNER_TYP is
   -- Liefert den groessten gemeinsamen Teiler der Betraege von Z1 und Z2.
   -- Falls Z2 gleich 0 ist, wird ein constraint_error ausgeloest. Falls
   -- Z1 gleich 0 ist, wird Z2 als Ergebnis geliefert.
      B1: ZAEHLER_TYP := abs(Z1);
      B2: ZAEHLER_TYP := abs(Z2);
   begin
      if    Z2 = 0 then
         raise constraint_error;
      elsif Z1 = 0 then
         return Z2;
      elsif B1 = B2 then
         return B1;
      end if;
      loop
         if B1 = 0 then
            return B2;
         elsif B2 = 0 then
            return B1;
         elsif B1 > B2 then
            B1 := B1 mod B2;
         else
            B2 := B2 mod B1;
         end if;
      end loop;
   end GGT;
   ------------------------------------------------------------------------      
   function K(R: RATIONAL) return RATIONAL is
   -- Liefert eine gekuerzte rationale Zahl mit dem Wert von R.
      ZL: ZAEHLER_TYP := ZAEHLER(R);
      NL: NENNER_TYP  := NENNER(R);
      TL: NENNER_TYP  := GGT(ZL, NL);
   begin
      return (Z => ZL/TL, N => NL/TL);
   end K;
   ------------------------------------------------------------------------
   function "+"(L, R: RATIONAL) return RATIONAL is
      ZL: ZAEHLER_TYP := L.Z*R.N + R.Z*L.N;
      NL: NENNER_TYP  := L.N * R.N;
      RL: RATIONAL    := (Z => ZL, N => NL); 
   begin
      return K(RL);
   end "+";
   ------------------------------------------------------------------------
   function "-"(L, R: RATIONAL) return RATIONAL is
      ZL: ZAEHLER_TYP := L.Z*R.N - R.Z*L.N;
      NL: NENNER_TYP  := L.N * R.N;
      RL: RATIONAL    := (Z => ZL, N => NL); 
   begin
      return K(RL);
   end "-";
   ------------------------------------------------------------------------
   function "*"(L, R: RATIONAL) return RATIONAL is
      ZL: ZAEHLER_TYP := L.Z * R.Z;
      NL: NENNER_TYP  := L.N * R.N;
      RL: RATIONAL    := (Z => ZL, N => NL);
   begin
      return K(RL);
   end "*";
   ------------------------------------------------------------------------
   function "/"(L, R: RATIONAL) return RATIONAL is
      ZL: ZAEHLER_TYP := L.Z * R.N;
      NL: NENNER_TYP  := L.N * R.Z;
      RL: RATIONAL    := (Z => ZL, N => NL);
   begin
      return K(RL);
   end "/";
   ------------------------------------------------------------------------
   function "/"(Z: ZAEHLER_TYP; N: NENNER_TYP) return RATIONAL is
      RL: RATIONAL := (Z => Z, N => N);
   begin
      return K(RL);
   end "/";
   ------------------------------------------------------------------------
   function ZAEHLER(R: RATIONAL) return ZAEHLER_TYP is
   begin
      return R.Z;
   end ZAEHLER;
   ------------------------------------------------------------------------
   function  NENNER(R: RATIONAL) return NENNER_TYP is
   begin
      return R.N;
   end NENNER;
   ------------------------------------------------------------------------
   procedure ASSIGN(L: out RATIONAL; R: in RATIONAL) is
   begin
      L := R;
   end ASSIGN;
end PAKET_06;