package PAKET_06 is
---------------------------------------------------------------------------
-- Stellt seinen Benutzern Typen und Operationen zum Rechnen mit rationalen
-- Zahlen zur Verfuegung. Jeder Wert des Untertyps RATIONAL repraesentiert
-- eine rationale Zahl. Mit den Operationen "+", "-", "*" und "/" kann man
-- zwei rationale Zahlen Addieren, Subtrahieren, Multiplizieren und Divi-
-- dieren. Die Ergebnisse dieser Operationen sind automatisch gekuerzt.
-- Mit einer weiteren Operation namens "/" kann man einen Zaehler vom
-- Untertp ZAEHLER_TYP und einen Nenner vom Untertyp NENNER_TYP zu einer
-- rationalen Zahl zusammenfassen (und automatisch kuerzen) lassen. Die
-- Funktion ZAEHLER liefert den Zaehler und die Funktion NENNER den Nenner
-- ihres Parameters R. Die Prozedur ASSIGN weist der rationalen Variablen L
-- den rationalen Wert R zu. Die Konstanten R0 und R1 sind RATIONALe Zahlen
-- mit den Werten 0 bzw. 1.
---------------------------------------------------------------------------
   type RATIONAL is limited private;
   function "+"(L, R: RATIONAL) return RATIONAL;
   function "-"(L, R: RATIONAL) return RATIONAL;
   function "*"(L, R: RATIONAL) return RATIONAL;
   function "/"(L, R: RATIONAL) return RATIONAL;
   ------------------------------------------------------------------------
   type     GANZ       is range -1e9..+1e9;
   subtype ZAEHLER_TYP is GANZ'base;
   subtype  NENNER_TYP is GANZ'base range 1..GANZ'base'last;
   function "/"(Z: ZAEHLER_TYP; N: NENNER_TYP) return RATIONAL;
   function ZAEHLER(R: RATIONAL) return ZAEHLER_TYP;
   function  NENNER(R: RATIONAL) return NENNER_TYP;
   procedure ASSIGN(L: out RATIONAL; R: in RATIONAL);
   ------------------------------------------------------------------------
private
   type RATIONAL is record
      Z: ZAEHLER_TYP := 0;
      N:  NENNER_TYP := 1;
   end record;
end PAKET_06;