with ada.text_io;
procedure REIHE_01 is
---------------------------------------------------------------------------
-- Ein eingeschraenkter Reihungstyp !BESTAND wird vereinbart.
-- Ein Reihungswert (SOLL_BESTAND) wird zur aktuellen Ausgabe ausgegeben.
---------------------------------------------------------------------------
   type GROESSE is range 34..48;             -- 15 Schuhgroessen
   type ANZAHL  is range  0..100;            -- Anzahlen von Schuhpaaren
   type BESTAND is array(GROESSE) of ANZAHL; -- Bestand eines Schuhladens
   ------------------------------------------------------------------------
   IST_BESTAND  : BESTAND := (41 => 5, 42 => 12, 44 => 13, others => 2);
   SOLL_BESTAND : BESTAND;
   ------------------------------------------------------------------------
   package GROESSE_EA is new ada.text_io.integer_io(num => GROESSE);
   package  ANZAHL_EA is new ada.text_io.integer_io(num => ANZAHL);
begin
   -- Die folgende Reihungszuweisung ersetzt 15 Komponentenzuweisungen:
   SOLL_BESTAND := IST_BESTAND;
   -- Jede Komponente des SOLL_BESTANDs um 3 erhoehe:
   for G in SOLL_BESTAND'range loop
      SOLL_BESTAND(G) := SOLL_BESTAND(G) + 3;
   end loop;
   -- Den SOLL_BESTAND zur aktuellen Ausgabe ausgeben:
   ada.text_io.put_line(item => "Der Soll-Bestand an Schuhen:");
   for G in GROESSE range SOLL_BESTAND'range loop
      ada.text_io.put(item => "Groesse");
      GROESSE_EA .put(item =>  G);
      ada.text_io.put(item => ", Anzahl Paare: ");
      ANZAHL_EA  .put(item =>  SOLL_BESTAND(G));
      ada.text_io.new_line;
   end loop;
end REIHE_01;