with ada.text_io;
procedure REIHE_02 is
---------------------------------------------------------------------------
-- Eine Reihung von Ganzzahlen namens ANZ wird auf verschiedene, typische 
-- Weisen bearbeitet.
---------------------------------------------------------------------------
   type    GANZ    is      range  0..15*100;
   type    GROESSE is      range 34..48;        -- 15 Schuhgroessen
   subtype ANZAHL  is GANZ range  0..100;       -- Anzahlen von Schuhpaaren
   type    BESTAND is array(GROESSE) of ANZAHL; -- Bestand eines Schuhladens
   ANZ   : BESTAND := (41 => 5, 42 => 12, 44 => 3, others => 2);
   SUMME : GANZ := 0;
   IST_SORTIERT, KEIN_WERT_DOPPELT : boolean;
   package GROESSE_EA is new ada.text_io.integer_io    ( num => GROESSE);
   package    GANZ_EA is new ada.text_io.integer_io    ( num => GANZ);
   package    BOOL_EA is new ada.text_io.enumeration_io(enum => boolean);
begin
   ------------------------------------------------------------------------
   -- Jeder Komponenten von ANZ den Wert 0 zuweisen:
   ANZ := (others => 0);
   ------------------------------------------------------------------------
   -- In jede Komponente von ANZ eine ANZAHL einlesen:
   ada.text_io.put_line(item => "Bitte 15 Ganzzahlen (0..100) eingeben:");
   for G in ANZ'range loop
      ada.text_io.put(item => "Anzahl Paare Groesse");
      GROESSE_EA .put(item =>  G);
      ada.text_io.put(item => ": ");
      GANZ_EA    .get(item =>  ANZ(G));
   end loop;
   ------------------------------------------------------------------------
   -- Alle Komponenten von ANZ zur SUMME addieren (und SUMME ausgeben):
   for G in ANZ'range loop
      SUMME := SUMME + ANZ(G);
   end loop;
   ada.text_io.put(item => "Die Summe ist gleich     ");
   GANZ_EA    .put(item => SUMME, width => 0);
   ada.text_io.new_line;
   ------------------------------------------------------------------------
   -- Jede Komponente von ANZ halbieren bzw. um 1 vermindern (und ausgeben):
   for G in ANZ'range loop
      if ANZ(G) mod 2 = 0 then -- wenn ANZ(G) eine gerade Zahl ist
         ANZ(G) := ANZ(G) / 2;
      else
         ANZ(G) := ANZ(G) - 1;
      end if;
   end loop;
   ada.text_io.put_line(item => "Die halbierten bzw. um 1 verminderten Zahlen:");
   for G in ANZ'range loop
      GANZ_EA.put(item => ANZ(G));
   end loop;
   ada.text_io.new_line;
   ------------------------------------------------------------------------
   -- Feststellen, ob ANZ sortiert ist:
   IST_SORTIERT := true;
   for G in ANZ'first .. ANZ'last-1 loop
   -- Wird evtl. fruehzeitig mit exit verlassen!
      if ANZ(G + 1) < ANZ(G) then
         IST_SORTIERT := false;
         exit;
      end if;
   end loop;
   ada.text_io.put(item => "IST_SORTIERT      hat den Wert ");
   BOOL_EA    .put(item =>  IST_SORTIERT);
   ada.text_io.new_line;
   ------------------------------------------------------------------------
   -- Feststellen, ob ANZ Werte doppelt enthaelt:
   KEIN_WERT_DOPPELT := true;
   for G1 in ANZ'first..ANZ'last-1 loop
      for G2 in G1+1..ANZ'last loop
      -- Wird evtl. fruehzeitig mit exit verlassen!
         if ANZ(G1) = ANZ(G2) then
            KEIN_WERT_DOPPELT := false;
            exit;
         end if;
      end loop;
   end loop;
   ada.text_io.put(item => "KEIN_WERT_DOPPELT hat den Wert ");
   BOOL_EA    .put(item =>  KEIN_WERT_DOPPELT);
   ada.text_io.new_line;
end REIHE_02;

 