with ada.text_io;
procedure REIHE_04 is
---------------------------------------------------------------------------
-- Reihungsvariablen werden mit Aggregaten initialisiert, Reihungen werden
-- "im Ganzen" bearbeitet, auf Teilreihungen wird zugegriffen.
---------------------------------------------------------------------------
   type    SEMESTER   is (SS90, WS90, SS91, WS91, SS92, WS92, SS93, WS93);
   type    ANZAHL     is range 0..100;
   type    TEILNEHMER is array(SEMESTER) of ANZAHL;
   package ANZAHL_EA  is new ada.text_io.integer_io(num => ANZAHL);
   ENGLISCH1 : TEILNEHMER := (WS90 => 67, WS91 => 58, WS92 => 62,
                              WS93 => 71, others => 0);
   SPANISCH1 : TEILNEHMER := (0, 67, 0, 58, 0, 62, 0, 71);
   RUSSISCH1 : TEILNEHMER := (others => 0);
   MATHE1    : TEILNEHMER := (WS90 | SS93 | WS93 => 25, SS91..WS92 => 31,
                              SS90 => 17);
   MATHE2    : TEILNEHMER := (17, 25, 31, 31, 31, 31, 25, 25);
begin
   RUSSISCH1 := (20, 25, 17, 23, 28, 31, 25, 27);
   SPANISCH1 := RUSSISCH1;
   ------------------------------------------------------------------------
   if ENGLISCH1 /= SPANISCH1 then
      ada.text_io.put_line(item => "ENGLISCH1 ist ungleich SPANISCH1!");
   else
      ada.text_io.put_line(item => "ENGLISCH1 ist gleich   SPANISCH1!");
   end if;
   ------------------------------------------------------------------------
   if MATHE1 = MATHE2 then
      ada.text_io.put_line(item => "MATHE1    ist gleich   MATHE2!");
   else
      ada.text_io.put_line(item => "MATHE1    ist ungleich MATHE2");
   end if;
   ------------------------------------------------------------------------
   RUSSISCH1(WS90..SS92) := (25, 17, 23, 28);
   SPANISCH1(WS90..SS92) := RUSSISCH1(WS91..SS93);
end REIHE_04;
