generic
   MAX_ANZ : natural;
   type E_TYP is private;
package SCHAB_11 is
-- Jede Instanz dieser Paketschablone dient zum Verwalten eines Stapels
-- von Elementen (vom Typ E_TYP). Der Stapel selbst ist im Rumpf
-- des Instanz-Paketes verborgen und bietet Platz fuer MAX_ANZ Elemente.
---------------------------------------------------------------------------
   procedure PUSH(ELEMENT: E_TYP);
   -- Wenn der Stapel voll ist, wir die Ausnahme UEBERLAUF ausgeloest.
   -- Sonst wird das ELEMENT auf den Stapel gelegt.
   ------------------------------------------------------------------------
   procedure POP;
   -- Wenn der Stapel leer ist, wird die Ausnahme UNTERLAUF ausgeloest.
   -- Sonst wird das oberste Element vom Stapel entfernt.
   ------------------------------------------------------------------------
   function TOP return E_TYP;
   -- Wenn der Stapel leer ist, wird die Ausnahme UNTERLAUF ausgeloest.
   -- Sonst wird eine Kopie des obersten Stapelelements als Ergebnis
   -- geliefert. Der Stapel bleibt unveraendert.
   ------------------------------------------------------------------------
   function ANZAHL return natural;
   -- Liefert die Anzahl der Elemente, die sich momentan auf dem
   -- Stapel befinden.
   ------------------------------------------------------------------------
   UEBERLAUF: exception; -- Wird evtl. von PUSH ausgeloest.
   UNTERLAUF: exception; -- Wird evtl. von POP oder TOP ausgeloest.
end SCHAB_11;