with ada.text_io, ada.numerics.generic_elementary_functions;
package body TAG_A_01 is
   package GLEIT_EA  is new ada.text_io.float_io(num => GLEIT);
   package ELEM_FUNK is new 
      ada.numerics.generic_elementary_functions(float_type => GLEIT);
   ------------------------------------------------------------------------
   function ABSTAND_U(P: PUNKT) return GLEIT is
   begin
      return ELEM_FUNK.sqrt(P.X ** 2 + P.Y ** 2);
   end ABSTAND_U;
   
   procedure SPIEGEL_U(P: in out PUNKT) is
   begin
      P.X := -P.X;
      P.Y := -P.Y;
   end SPIEGEL_U;
   
   procedure PUT(ITEM: PUNKT) is
   begin
      ada.text_io.put(item => "X: ");
      GLEIT_EA   .put(item => ITEM.X);
      ada.text_io.put(item => " Y: ");
      GLEIT_EA   .put(item => ITEM.Y);
      ada.text_io.put(item => " AU: ");
      GLEIT_EA   .put(item => ABSTAND_U(P => ITEM));
      ada.text_io.new_line;
   end PUT;
   ------------------------------------------------------------------------
   function FLAECHE(Q:QUADRAT) return GLEIT is
   begin
      return 4.0 * Q.DELTA_X**2;
   end FLAECHE;
   
   function UMFANG(Q: QUADRAT) return GLEIT is
   begin
      return 8.0*Q.DELTA_X;
   end UMFANG;
   
   procedure PUT(ITEM: QUADRAT) is
   begin
      ada.text_io.put(item => "Quadrat mit Mittelpunkt bei ");
      PUT(ITEM => PUNKT(ITEM));
      ada.text_io.put(item => "Seite:    ");
      GLEIT_EA   .put(item => 2.0 * ITEM.DELTA_X);
      ada.text_io.new_line;
      ada.text_io.put(item => "Flaeche:  ");
      GLEIT_EA   .put(item => FLAECHE(Q => ITEM));
      ada.text_io.put(item => " Umfang:  ");
      GLEIT_EA   .put(item => UMFANG(Q => ITEM));
      ada.text_io.new_line(spacing => 2);
   end PUT;
   ------------------------------------------------------------------------
   function FLAECHE(R: RECHTECK) return GLEIT is
   begin
      return 4.0 * R.DELTA_X * R.DELTA_Y;
   end FLAECHE;
   
   function UMFANG(R: RECHTECK) return GLEIT is
   begin
      return 4.0 * (R.DELTA_X + R.DELTA_Y);
   end UMFANG;
   
   function FORMAT(R: RECHTECK) return GLEIT is
   -- Liefert den Quotienten X-Seite durch Y-Seite
   begin
      return R.DELTA_X / R.DELTA_Y;
   end FORMAT;
   
   procedure PUT(ITEM: RECHTECK) is
   -- Gibt ITEM in Textform zur aktuellen Ausgabe aus
   begin
      ada.text_io.put(item => "Rechteck mit Mittelpunkt bei ");
      PUT(ITEM => PUNKT(ITEM));
      ada.text_io.put(item => "X-Seite:  ");
      GLEIT_EA   .put(item => 2.0 * ITEM.DELTA_X);
      ada.text_io.put(item => " Y-Seite: ");
      GLEIT_EA   .put(item => 2.0 * ITEM.DELTA_Y);
      ada.text_io.new_line;
      ada.text_io.put(item => "Flaeche:  ");
      GLEIT_EA   .put(item => FLAECHE(R => ITEM));
      ada.text_io.put(item => " Umfang:  ");
      GLEIT_EA   .put(item => UMFANG(R => ITEM));
      ada.text_io.new_line;
      ada.text_io.put(item => "Format:   ");
      GLEIT_EA   .put(item => FORMAT(R => ITEM));
      ada.text_io.new_line(spacing => 2);
   end PUT;
   ------------------------------------------------------------------------
   function FLAECHE(K: KREIS) return GLEIT is
   begin
      return ada.numerics.pi * K.RADIUS**2;
   end FLAECHE;
   
   function UMFANG(K: KREIS) return GLEIT is
   begin
      return 2.0 * ada.numerics.pi * K.RADIUS;
   end UMFANG;
   
   procedure PUT(ITEM: KREIS) is
   begin
      ada.text_io.put(item => "Kreis mit Mittelpunkt bei ");
      PUT(ITEM => PUNKT(ITEM));
      ada.text_io.put(item => "Radius:   ");
      GLEIT_EA   .put(item => ITEM.RADIUS);
      ada.text_io.new_line;
      ada.text_io.put(item => "Flaeche:  ");
      GLEIT_EA   .put(item => FLAECHE(K => ITEM));
      ada.text_io.put(item => " Umfang:  ");
      GLEIT_EA   .put(item => UMFANG(K => ITEM));
      ada.text_io.new_line(spacing => 2);
   end PUT;
   ------------------------------------------------------------------------
   procedure SCHIEBE(CP: in out PUNKT'class; DX, DY : GLEIT) is
   begin
      CP.X := CP.X + DX;
      CP.Y := CP.Y + DY;
      PUT(ITEM => CP);
   end SCHIEBE;
   ------------------------------------------------------------------------
end TAG_A_01;
         