with ada.text_io, ada.numerics.generic_elementary_functions;
package body TAG_B_01 is
   package GLEIT_EA  is new ada.text_io.float_io(num => GLEIT);
   package ELEM_FUNK is new 
      ada.numerics.generic_elementary_functions(float_type => GLEIT);
   ------------------------------------------------------------------------
   function MAKE(MX, MY: GLEIT) return PUNKT is
   begin
      return (X=> MX, Y => MY);
   end MAKE;
   
   procedure MACHE_PUNKT(MX, MY: GLEIT; P: out PUNKT) is
   begin
      P.X := MX;
      P.Y := MY;
   end MACHE_PUNKT;
   
   function ABSTAND_U(P: PUNKT) return GLEIT is
   begin
      return ELEM_FUNK.sqrt(P.X ** 2 + P.Y ** 2);
   end ABSTAND_U;
   
   procedure SPIEGEL_U(P: in out PUNKT) is
   begin
      P.X := -P.X;
      P.Y := -P.Y;
   end SPIEGEL_U;
   
   procedure PUT(ITEM: PUNKT) is
   begin
      ada.text_io.put(item => "X: ");
      GLEIT_EA   .put(item => ITEM.X);
      ada.text_io.put(item => " Y: ");
      GLEIT_EA   .put(item => ITEM.Y);
      ada.text_io.put(item => " AU: ");
      GLEIT_EA   .put(item => ABSTAND_U(P => ITEM));
      ada.text_io.new_line;
   end PUT;
   ------------------------------------------------------------------------
   function MAKE(MX, MY, SEITE: GLEIT) return QUADRAT is
   begin
      return (X=>MX, Y=>MY, DELTA_X=>SEITE/2.0);
   end MAKE;
   
   function MAKE(MX, MY: GLEIT) return QUADRAT is
   begin
      return MAKE(MX=>MX, MY=>MY, SEITE=>0.0);
   end MAKE;
   
   procedure MACHE_QUADRAT(MX, MY, SEITE: GLEIT; Q: out QUADRAT) is
   begin
      MACHE_PUNKT(MX=>MX, MY=>MY, P=>PUNKT(Q));
      Q.DELTA_X := SEITE/2.0;
   end MACHE_QUADRAT;
   
   function FLAECHE(Q:QUADRAT) return GLEIT is
   begin
      return 4.0 * Q.DELTA_X**2;
   end FLAECHE;
   
   function UMFANG(Q: QUADRAT) return GLEIT is
   begin
      return 8.0*Q.DELTA_X;
   end UMFANG;
   
   procedure PUT(ITEM: QUADRAT) is
   begin
      ada.text_io.put(item => "Quadrat mit Mittelpunkt bei ");
      PUT(ITEM => PUNKT(ITEM));
      ada.text_io.put(item => "Seite:    ");
      GLEIT_EA   .put(item => 2.0 * ITEM.DELTA_X);
      ada.text_io.new_line;
      ada.text_io.put(item => "Flaeche:  ");
      GLEIT_EA   .put(item => FLAECHE(Q => ITEM));
      ada.text_io.put(item => " Umfang:  ");
      GLEIT_EA   .put(item => UMFANG(Q => ITEM));
      ada.text_io.new_line(spacing => 2);
   end PUT;
   ------------------------------------------------------------------------
end TAG_B_01;
         