with ada.text_io;
procedure TASKS_02 is
---------------------------------------------------------------------------
-- Drei Tasks (ALICE, BERTA und das Hauptprogramm) geben "um die Wette"
-- Zeichenketten zur aktuellen Ausgabe aus. Nach jeweils 10 Ausgaben
-- synchronisieren sich ALICE und BERTA und beginnen eine neue Zeile.
---------------------------------------------------------------------------
   procedure BELASTUNG(WIE_STARK: natural) is
   -- Dient zum "Belasten" von Tasks mit "Rechenarbeit".
      INT1: integer := -1;
   begin
      for I in natural range 0..WIE_STARK loop
         INT1 := INT1 * INT1; -- "Komplizierte Berechnung!"
      end loop;
   end BELASTUNG;
   --------------------------------------------------------
   procedure PUT(ITEM: string) is
   -- Gibt ITEM zehnmal zur aktuellen Ausgabe aus, jeweils mit einer
   -- Ziffer zwischen '0' und '9' und einem Blank dahinter:
      BLANK: constant character := ' ';
   begin
      for C2 in character range '0'..'9' loop
         ada.text_io.put(item => ITEM & C2 & BLANK);
         BELASTUNG(WIE_STARK => 50_000);
      end loop;
   end PUT;
   --------------------------------------------------------
   task ALICE is      -- Spezifikation von ALICE
      entry EINGANG1; -- ALICE hat einen Eingang! 
   end ALICE;
   task BERTA;        -- Spezifikation von BERTA (ohne Eingaenge)
   --------------------------------------------------------
   task body ALICE is       -- Rumpf von ALICE
   begin
      for C1 in character range '0'..'5' loop
         PUT(ITEM => "Alice" & C1);
         accept EINGANG1 do
            ada.text_io.new_line;
         end EINGANG1;
         BELASTUNG(WIE_STARK => 1_000);
      end loop;
   end ALICE;
   --------------------------------------------------------
   task body BERTA is       -- Rumpf von Berta
   begin
      for C1 in character range '0'..'5' loop
         PUT(ITEM => "Berta" & C1);
         ALICE.EINGANG1;
      end loop;
      BELASTUNG(WIE_STARK => 100);
   end BERTA;
   --------------------------------------------------------
begin
   for C1 in character range '0'..'5' loop -- Anweisungen
      PUT(ITEM => "Haupt" & C1);           -- des Haupt-
      BELASTUNG(WIE_STARK => 100);         -- programms
   end loop;
end TASKS_02;
