with ada.text_io;
procedure TASKS_03 is
---------------------------------------------------------------------------
-- Drei Tasks (ALICE, BERTA und das Hauptprogramm) geben "um die Wette"
-- Zeichenketten zur aktuellen Ausgabe aus. Die Task ALICE fuehrt insgesamt
-- 6 Rendezvous durch, 3 mit BERTA und 3 mit der Haupttask. Bei jedem
-- Rendezvous wird eine Meldung "Alice trifft BERTA" bzw. "Alice trifft
-- Haupt" zur aktuellen Ausgabe ausgegeben.
---------------------------------------------------------------------------
   procedure BELASTUNG(WIE_STARK: natural) is
   -- Dient zum "Belasten" von Tasks mit "Rechenarbeit".
      INT1: integer := -1;
   begin
      for I in natural range 0..WIE_STARK loop
         INT1 := INT1 * INT1; -- "Komplizierte Berechnung!"
      end loop;
   end BELASTUNG;
   --------------------------------------------------------
   procedure PUT(ITEM: string) is
   -- Gibt ITEM zehnmal zur aktuellen Ausgabe aus, jeweils mit einer
   -- Ziffer zwischen '0' und '9' und einem Blank dahinter:
      BLANK: constant character := ' ';
   begin
      for C2 in character range '0'..'9' loop
         ada.text_io.put(item => ITEM & C2 & BLANK);
         BELASTUNG(WIE_STARK => 50_000);
      end loop;
   end PUT;
   --------------------------------------------------------
   task ALICE is            -- Spezifikation von ALICE
      entry EINGANG1(WER_DA: string); 
   end  ALICE;
   task BERTA;              -- Spezifikation von BERTA (ohne Eingaenge)
   --------------------------------------------------------
   task body ALICE is       -- Rumpf von ALICE
   begin
      for C1 in character range '0'..'5' loop
         PUT(ITEM => "Alice" & C1);
         accept EINGANG1(WER_DA: string) do
            ada.text_io.new_line;
            ada.text_io.put_line("Alice trifft " & WER_DA & " ----------");
         end EINGANG1;
         BELASTUNG(WIE_STARK => 1_000);
      end loop;
   end ALICE;
   --------------------------------------------------------
   task body BERTA is       -- Rumpf von Berta
   begin
      for C1 in character range '0'..'2' loop
         PUT(ITEM => "Berta" & C1);
         ALICE.EINGANG1(WER_DA => "Berta");
      end loop;
      BELASTUNG(WIE_STARK => 100);
   end BERTA;
   --------------------------------------------------------
begin
   for C1 in character range '0'..'2' loop -- Anweisungen
      PUT(ITEM => "Haupt" & C1);           -- des Haupt-
      ALICE.EINGANG1(WER_DA => "Haupt");   -- programms
      BELASTUNG(WIE_STARK => 100);
   end loop;
end TASKS_03;