with ada.text_io;
procedure TASKS_04 is
---------------------------------------------------------------------------
-- Drei Tasks (ALICE, BERTA und das Hauptprogramm) geben "um die Wette"
-- Zeichenketten zur aktuellen Ausgabe aus. BERTA und die Haupttask rufen
-- je dreimal den EINGANG1 von ALICE auf. ALICE akzeptiert zunaechst die
-- drei Aufrufe von BERTA, aber nur einen Aufruf der Haupttask und
-- schickt die Haupttask mit requeque zum privaten EINGANG2. Erst spaeter
-- verarbeitet ALICE die Aufrufe der Haupttask endgueltig (einen Aufruf
-- am EINGANG2 und zwei am EINGANG1).
---------------------------------------------------------------------------
   procedure BELASTUNG(WIE_STARK: natural) is
   -- Dient zum "Belasten" von Tasks mit "Rechenarbeit".
      INT1: integer := -1;
   begin
      for I in natural range 0..WIE_STARK loop
         INT1 := INT1 * INT1; -- "Komplizierte Berechnung!"
      end loop;
   end BELASTUNG;
   --------------------------------------------------------
   procedure PUT(ITEM: string) is
   -- Gibt ITEM zehnmal zur aktuellen Ausgabe aus, jeweils mit einer
   -- Ziffer zwischen '0' und '9' und einem Blank dahinter:
      BLANK: constant character := ' ';
   begin
      for C2 in character range '0'..'9' loop
         ada.text_io.put(item => ITEM & C2 & BLANK);
         BELASTUNG(WIE_STARK => 50_000);
      end loop;
   end PUT;
   --------------------------------------------------------
   task ALICE is            -- Spezifikation von ALICE
      entry EINGANG1(WER_DA: string);
   private
      entry EINGANG2(WER_DA: string);
   end  ALICE;
   task BERTA;              -- Spezifikation von BERTA (ohne Eingaenge)
   --------------------------------------------------------
   task body ALICE is       -- Rumpf von ALICE
   begin
      for C1 in character range '0'..'3' loop
         PUT(ITEM => "Alice" & C1);
         accept EINGANG1(WER_DA: string) do
            if WER_DA = "Berta" then
               ada.text_io.new_line;
               ada.text_io.put_line("Alice trifft " & WER_DA & " -------");
            else                 -- Dann wird es wohl die Haupttask sein.
               requeue EINGANG2; -- Die soll vor EINGANG2 warten!
            end if;
         end EINGANG1;
         BELASTUNG(WIE_STARK => 1_000);
      end loop;
      accept EINGANG2(WER_DA: string) do
         ada.text_io.new_line;
         ada.text_io.put_line("Alice trifft " & WER_DA & " am EINGANG2");
      end EINGANG2;
      for C1 in character range '4'..'5' loop
         PUT(ITEM => "Alice" & C1);
         accept EINGANG1(WER_DA: string) do
            ada.text_io.new_line;
            ada.text_io.put_line("Alice trifft " & WER_DA & " +++++++");
         end EINGANG1;
      end loop;
   end ALICE;
   --------------------------------------------------------
   task body BERTA is       -- Rumpf von Berta
   begin
      for C1 in character range '0'..'2' loop
         PUT(ITEM => "Berta" & C1);
         ALICE.EINGANG1(WER_DA => "Berta");
      end loop;
      BELASTUNG(WIE_STARK => 100);
   end BERTA;
   --------------------------------------------------------
begin
   for C1 in character range '0'..'2' loop -- Anweisungen
      PUT(ITEM => "Haupt" & C1);           -- des Haupt-
      ALICE.EINGANG1(WER_DA => "Haupt");   -- programms
      BELASTUNG(WIE_STARK => 100);
   end loop;
end TASKS_04;