with ada.text_io;
procedure TASKS_05 is
---------------------------------------------------------------------------
-- Die Reihung TAB1 (siehe unten) besteht aus Tasks des Typs !AUSGABE
-- Jede AUSGABE-Task hat eine Diskriminante namens NAME, durch deren Wert
-- sie sich von anderen AUSGABE-Tasks unterscheidet.
-- Ausserdem hat jede AUSGABE-Task einen Eingang namens START und "beginnt
-- ihre eigentliche Arbeit" erst nach einem Rendezvous an diesem Eingang.
-- Das Hauptprogramm "startet" alle Tasks in der Reihung TAB1, indem es
-- ihre START-Eingaenge aufruft.
---------------------------------------------------------------------------
   procedure BELASTUNG(WIE_STARK: natural) is
   -- Dient zum "Belasten" von Tasks mit "Rechenarbeit".
      INT1 : integer := -1;
   begin
      for I in natural range 0..WIE_STARK loop
         INT1 := INT1 * INT1;
      end loop;
   end BELASTUNG;
   ------------------------------------------------------------------
   procedure PUT(ITEM: string) is
   -- Gibt ITEM zehnmal zur aktuellen Ausgabe aus, jeweils mit einer
   -- Ziffer zwischen '0' und '9' und einem Blank dahinter.
      BLANK: constant character := ' ';
   begin
      for C2 in character range '0'..'9' loop
         ada.text_io.put(item => ITEM & C2 & BLANK);
         BELASTUNG(WIE_STARK => 100);
      end loop;
   end PUT;
   ------------------------------------------------------------------
   AKTUELLES_ZEICHEN: character := character'pred('A');
   function NEUES_ZEICHEN return character is
   -- Liefert beim ersten Aufruf das Zeichen 'A' und bei jedem
   -- weiteren Aufruf das jeweils naechste Zeichen ('B', 'C' etc.).
   -- Achtung: Greift auf die globale Variable AKTUELLES_ZEICHEN zu!
   begin
      AKTUELLES_ZEICHEN := character'succ(AKTUELLES_ZEICHEN);
      return AKTUELLES_ZEICHEN;
   end NEUES_ZEICHEN;
   ------------------------------------------------------------------
   task type AUSGABE(NAME: character := NEUES_ZEICHEN) is
      entry START;
   end       AUSGABE;
   ------------------------------------------------------------------
   task body AUSGABE is
   begin
      accept START;             -- Hier warten bis zum "Startzeichen"
      for C1 in character range '0'..'5' loop
         PUT(ITEM => NAME & C1);
         BELASTUNG(WIE_STARK => 100_000);
      end loop;
   end AUSGABE;
   ------------------------------------------------------------------
   type   TASK_TAB is array(natural range <>) of AUSGABE;
   TAB1 : TASK_TAB(1..3);       -- Eine Reihung von drei AUSGABE-Tasks
   ------------------------------------------------------------------
begin
   ada.text_io.put_line(item => "TASKS_05: Jetzt geht es los!");
   for I in natural range TAB1'range loop
      TAB1(I).START;            -- Startzeichen fuer die Task TAB1(I)
   end loop;
end TASKS_05;