with ada.text_io;
procedure TASKS_06 is
---------------------------------------------------------------------------
-- Ein Zeigertyp Z_AUSGABE wird vereinbart, dessen Werte auf Tasks eines
-- Taskstyps AUSGABE zeigen. In einer Schleife werden mit dem Allokator
-- new mehrere AUSGABE-Tasks erzeugt und gestartet.
---------------------------------------------------------------------------
   procedure BELASTUNG(WIE_STARK: natural) is
   -- Dient zum "Belasten" von Tasks mit "Rechenarbeit".
      INT1 : integer := -1;
   begin
      for I in natural range 0..WIE_STARK loop
         INT1 := INT1 * INT1;
      end loop;
   end BELASTUNG;
   ------------------------------------------------------------------
   procedure PUT(ITEM: string) is
   -- Gibt ITEM zehnmal zur aktuellen Ausgabe aus, jeweils mit einer
   -- Ziffer zwischen '0' und '9' und einem Blank dahinter.
      BLANK: constant character := ' ';
   begin
      for C2 in character range '0'..'9' loop
         ada.text_io.put(item => ITEM & C2 & BLANK);
         BELASTUNG(WIE_STARK => 100);
      end loop;
   end PUT;
   ------------------------------------------------------------------
   task type AUSGABE(NAME: character); -- Ohne Eingaenge
   ------------------------------------------------------------------
   task body AUSGABE is
   begin
      for C1 in character range '0'..'5' loop
         PUT(ITEM => NAME & C1);
         BELASTUNG(WIE_STARK => 100_000);
      end loop;
   end AUSGABE;
   ------------------------------------------------------------------
   type  Z_AUSGABE  is access AUSGABE; -- Zeiger auf AUSGABE-Tasks
   type  ZEIGER_TAB is array(character range 'A'..'Z') of Z_AUSGABE;
   TAB2: ZEIGER_TAB;                   -- Reihung von Zeigern
   LBI:  character range TAB2'range;   -- Letzter belegter Index
   ------------------------------------------------------------------
begin
   ada.text_io.put(item => "TASKS_06: Letzter (grosser!) Buchstabe? ");
   ada.text_io.get(item => LBI);
   for BUCHSTABE in character range TAB2'first..LBI loop
      TAB2(BUCHSTABE) := new AUSGABE(NAME => BUCHSTABE);
   end loop;
end TASKS_06;