with ada.text_io;
procedure TASKS_09 is
---------------------------------------------------------------------------
-- Demonstriert die Wirkung einer asynchronen select-Anweisung mit einer
-- delay-Anweisung als Ausloeser (triggering statement).
-- Liest wiederholt eine Zeitdauer (in Sekunden) ein, bis der Benutzer als
-- Zeitdauer 0.0 eingibt. Probiert jedesmal, ob in der eingelesenen Zeit
-- der Rumpf einer Schleife 5_000_000 Mal ausgefuehrt werden kann. Wenn die
-- Zeit nicht reicht, wird die Meldung "Schleife dauert zu lange!" zur 
-- aktuellen Ausgabe ausgegeben. 
---------------------------------------------------------------------------
   ZAEHLER: natural := 0;
   DAUER:   duration;
   package NATU_EA is new ada.text_io.integer_io(num => natural);
   package DURA_EA is new ada.text_io.fixed_io  (num => duration);
begin
   loop
      ada.text_io.put(item => "TASKS_09: Eine Dauer (0.0 zum Beenden): ");
      DURA_EA    .get(item =>  DAUER);
   exit when DAUER = 0.0;
      select
         delay DAUER;
         ada.text_io.put_line(item => "  Schleife dauert zu lange!");
      then abort
         for I in natural range 1..5_000_000 loop
            ZAEHLER := I;
         end loop;
      end select;
      ada.text_io.put(item => "  ZAEHLER ist gleich ");
      NATU_EA    .put(item =>    ZAEHLER);
      ada.text_io.new_line;
   end loop;
   ada.text_io.put_line(item => "TASKS_09: Das war's erstmal!");
end TASKS_09;
