with ada.text_io;
procedure TASKS_10 is
---------------------------------------------------------------------------
-- Demonstriert die Wirkung einer asynchronen select-Anweisung, die einen
-- Eingangsaufruf als ausloesende Anweisung (triggering statement) enthaelt.
-- Insgesamt finden genau zwei Rendezvous zwischen der Task ALICE und der
-- Haupttask statt. Ein drittes Rendezvous wird von der Haupttask zwar
-- "beantragt", aber dann abgesagt, bevor es stattfinden kann. Vor dem
-- zweiten Rendezvous muss die Haupttask ca. 2.0 Sekunden warten.
---------------------------------------------------------------------------
   task ALICE is
      entry EINGANG1;
   end ALICE;
   ---------------------
   task body ALICE is
   begin
      accept EINGANG1 do
         ada.text_io.put_line(item => "Alice: Rendezvous 1 mit Haupt!");
      end EINGANG1;
      ------------------
      delay 2.0; -- Alice troedelt, damit die Haupttask warten muss.
      ------------------
      accept EINGANG1 do
         ada.text_io.put_line(item => "Alice: Rendezvous 2 mit Haupt!");
      end EINGANG1;
      ------------------
      delay 3.0; -- Alice wartet ein Weilchen, bevor sie sich beendet.
      ------------------
   end ALICE;
   ------------------------------------------------------------------------
begin -- TASKS_10
   ada.text_io.put_line(item => "TASKS_10:   Jetzt geht es los!");
   ------------------------------------------------------------------------
   select
      ALICE.EINGANG1; -- Dieser Aufruf wird von ALICE sofort akzeptiert.
   then abort
      loop
         ada.text_io.put_line(item => "Haupt: Warte auf Rendezvous 1!");
         delay 0.5;
      end loop;
   end select;
   ------------------------------------------------------------------------
   select
      ALICE.EINGANG1; -- Dieser Aufruf wird nach ca. 2.0 sec. akzeptiert.
   then abort
      loop
         ada.text_io.put_line(item => "Haupt: Warte auf Rendezvous 2!");
         delay 0.5;
      end loop;
   end select;
   ------------------------------------------------------------------------
   select
      ALICE.EINGANG1; -- Diesen Aufruf sagt die Haupttask wieder ab.
   then abort
      ada.text_io.put_line(item => "Haupt: Sage Rendezvous 3 ab!!!");
   end select;
   ------------------------------------------------------------------------
   ada.text_io.put_line(item => "TASKS_10:   Das war's erstmal!");
end TASKS_10;
