with ada.text_io;
procedure TASKS_12 is
---------------------------------------------------------------------------
-- Enthaelt nur ein paar Vereinbarungen, "macht aber nichts".
-- Verenbart werden ein geschuetzter Typ !LAGER_TYP, zwei geschuetzte
-- Objekte dieses Typs (LAGER1 und LAGER2) und eine Reihung (TAB1) mit
-- LAGER_TYP-Konponenten.
---------------------------------------------------------------------------
   protected type LAGER_TYP(MAX_ANZAHL: natural) is
      entry REIN(KISTE: in character);
      entry RAUS(KISTE: out character);
   private
      REGAL      : string(1..MAX_ANZAHL);
      AKT_ANZAHL : natural := 0;
      REIN_PLATZ : natural := 1;
      RAUS_PLATZ : natural := 1;
   end LAGER_TYP;
   ------------------------------------------------------------------------
   protected body LAGER_TYP is
      entry REIN(KISTE: in character) when AKT_ANZAHL < MAX_ANZAHL is
      begin
         REGAL(REIN_PLATZ) := KISTE;
         REIN_PLATZ        := REIN_PLATZ mod MAX_ANZAHL + 1;
         AKT_ANZAHL        := AKT_ANZAHL + 1;
      end REIN;
      ---------------------------------------------------------------------
      entry RAUS(KISTE: out character) when AKT_ANZAHL > 0 is
      begin
         KISTE             := REGAL(RAUS_PLATZ);
         RAUS_PLATZ        := RAUS_PLATZ mod MAX_ANZAHL + 1;
         AKT_ANZAHL        := AKT_ANZAHL - 1;
      end RAUS;
   end LAGER_TYP;
   ------------------------------------------------------------------------
   LAGER1 : LAGER_TYP(MAX_ANZAHL =>   3);
   LAGER2 : LAGER_TYP(MAX_ANZAHL => 500);
   subtype LAGER_TYP_25 is LAGER_TYP(MAX_ANZAHL => 25);
   type  LAGER_TAB is array(natural range <>) of LAGER_TYP_25;
   TAB1: LAGER_TAB(1..3);
begin
   ada.text_io.put_line("TASKS_12 enthaelt fast nur Vereinbarungen!");
end TASKS_12;