with SCHAB_08, ada.text_io;
procedure TESTS_08 is
-- Kleines Testprogramm zum Testen der Prozedurschablone SCHAB_04.
   type ANSCHRIFT is record
      NAME : string(1..4) := (others => '?');
      NR   : integer      := 0;
   end record;
   type TABELLE is array(natural range <>) of ANSCHRIFT;
   ------------------------------------------------------------------------
   function AUF_NACH_NAME(AN1, AN2: ANSCHRIFT) return boolean is
   begin
      return AN1.NAME <= AN2.NAME;
   end AUF_NACH_NAME;
   ------------------------------------------------------------------------
   function AB_NACH_NR(AN1, AN2: ANSCHRIFT) return boolean is
   begin
      return AN1.NR >= AN2.NR;
   end AB_NACH_NR;
   ------------------------------------------------------------------------
   procedure SORT_AUF_NAME is new SCHAB_08(INDX    => natural,
                                           KOMP    => ANSCHRIFT,
                                           REIH    => TABELLE,
                                           SIND_OK => AUF_NACH_NAME);
   procedure SORT_AB_NR    is new SCHAB_08(INDX    => natural,
                                           KOMP    => ANSCHRIFT,
                                           REIH    => TABELLE,
                                           SIND_OK => AB_NACH_NR);
   ------------------------------------------------------------------------
   procedure PUT(ITEM: TABELLE) is
   -- Gibt ITEM in lesbarer Form zur aktuellen Ausgabe aus.
   begin
      for I in natural range ITEM'range loop
         ada.text_io.put(item => "Name: " & ITEM(I).NAME);
         ada.text_io.put(item => " Nr.: " & integer'image(ITEM(I).NR));
         ada.text_io.new_line;
      end loop;
      ada.text_io.new_line;
   end PUT;
   ------------------------------------------------------------------------
   TAB1 : TABELLE(1..3) := (("OTTO", 17), ("EMIL", 35), ("KARL", -23));
begin -- TESTS_08
   PUT          (ITEM => TAB1);
   SORT_AUF_NAME(R    => TAB1);
   PUT          (ITEM => TAB1);
   SORT_AB_NR   (R    => TAB1);
   PUT          (ITEM => TAB1);
end TESTS_08;