with SCHAB_10, ada.text_io;
procedure TESTS_10 is
-- Kleines Testprogramm zum Testen der Funktionsschablone SCHAB_10.
   type MINUTEN is record
      MIN : natural             := 0;
      SEK : natural range 0..60 := 0;
   end record;
   type STUNDEN is record
      STD : natural             := 0;
      MIN : natural range 0..60 := 0;
   end record;
   type TAGE is record
      TGE : natural             := 0;
      STD : natural range 0..60 := 0;
   end record;
   ------------------------------------------------------------------------
   MIN1, MIN2 : MINUTEN;
   STD1       : STUNDEN;
   TGE1       : TAGE;
   ------------------------------------------------------------------------
   function MIN_IN_STD(M: MINUTEN) return STUNDEN is
      S : STUNDEN := (STD => M.MIN / 60, MIN => M.MIN mod 60);
   begin
      return S;
   end MIN_IN_STD;
   function STD_IN_TGE(S: STUNDEN) return TAGE is
      T : TAGE := (TGE => S.STD / 24, STD => S.STD mod 24);
   begin
      return T;
   end STD_IN_TGE;
   function TGE_IN_MIN(T: TAGE) return MINUTEN is
      M : MINUTEN := (MIN => ((T.TGE*24)+T.STD)*60, SEK => 0);
   begin
      return M;
   end TGE_IN_MIN;
   ------------------------------------------------------------------------
   function MIN_IN_TGE is new SCHAB_10(ANY1 => MINUTEN,
                                       ANY2 => STUNDEN,
                                       ANY3 => TAGE,
                                       F1   => MIN_IN_STD,
                                       F2   => STD_IN_TGE);
   function STD_IN_MIN is new SCHAB_10(ANY1 => STUNDEN,
                                       ANY2 => TAGE,
                                       ANY3 => MINUTEN,
                                       F1   => STD_IN_TGE,
                                       F2   => TGE_IN_MIN);
   function TGE_IN_STD is new SCHAB_10(ANY1 => TAGE,
                                       ANY2 => MINUTEN,
                                       ANY3 => STUNDEN,
                                       F1   => TGE_IN_MIN,
                                       F2   => MIN_IN_STD);
   ------------------------------------------------------------------------
   package NATURAL_EA is new ada.text_io.integer_io(num => natural);
   procedure PUT(M: MINUTEN) is
   begin
      NATURAL_EA .put(item => M.MIN);
      ada.text_io.put(item => " Min.");
      NATURAL_EA .put(item => M.SEK);
      ada.text_io.put(item => " Sek.");
      ada.text_io.new_line;
   end PUT;
   procedure PUT(S: STUNDEN) is
   begin
      NATURAL_EA .put(item => S.STD);
      ada.text_io.put(item => " Std.");
      NATURAL_EA .put(item => S.MIN);
      ada.text_io.put(item => " Min.");
      ada.text_io.new_line;
   end PUT;
   procedure PUT(T: TAGE) is
   begin
      NATURAL_EA .put(item => T.TGE);
      ada.text_io.put(item => " Tge.");
      NATURAL_EA .put(item => T.STD);
      ada.text_io.put(item => " Std.");
      ada.text_io.new_line;
   end PUT;
   ------------------------------------------------------------------------
begin
   MIN1 := (MIN => 5_000, SEK => 37);
   TGE1 := MIN_IN_TGE(P => MIN1);
   STD1 := TGE_IN_STD(P => TGE1);
   MIN2 := STD_IN_MIN(P => STD1);
   PUT(M => MIN1);
   PUT(T => TGE1);
   PUT(S => STD1);
   PUT(M => MIN2);
end TESTS_10;