with SCHAB_15, ada.text_io;
procedure TESTS_15 is
-- Kleines Testprogramm zum Testen der Schablone SCHAB_15.
   type FARBE is (ROT, GRUEN, BLAU);
   type GANZ  is range 0..99;
   type REIH1 is array(FARBE range <>) of GANZ;
   type REIH2 is array(GANZ  range <>) of FARBE;
   ------------------------------------------------------------------------
   package FARBE_EA is new ada.text_io.enumeration_io(enum => FARBE);
   package  GANZ_EA is new ada.text_io.integer_io(num => GANZ);
   -- Die folgenden GET- und PUT-Prozeduren muessen vereinbart werden, weil
   -- die Prozeduren FARBE_EA.get, FARBE_EA.put, GANZ_EA.get und GANZ_EA.put
   -- mehr als einen Parameter haben, SCHAB_15 aber einstellige Prozeduren
   -- fuer die formalen Prozeduren GET und PUT erwartet:
   procedure GET_F(ITEM: out FARBE) is
   begin
      FARBE_EA.get(item => ITEM);
   end GET_F;
   ----------------------------------
   procedure PUT_F(ITEM: in FARBE) is
   begin
      FARBE_EA.put(item => ITEM, width => FARBE'width);
   end PUT_F;
   ----------------------------------
   procedure GET_G(ITEM: out GANZ) is
   begin
      GANZ_EA.get(item => ITEM);
   end GET_G;
   ----------------------------------
   procedure PUT_G(ITEM: GANZ) is
   begin
      GANZ_EA.put(item => ITEM);
   end PUT_G;
   ------------------------------------------------------------------------
   package REIH1_SEA is new SCHAB_15(INDX    => FARBE,
                                     KOMP    => GANZ,
                                     REIH    => REIH1,
                                     SIND_OK => "<=",    -- aufsteigend
                                     GET     => GET_G,   -- GET fuer GANZ
                                     PUT     => PUT_G);  -- PUT fuer GANZ
   package REIH2_SEA is new SCHAB_15(INDX    => GANZ,
                                     KOMP    => FARBE,
                                     REIH    => REIH2,
                                     SIND_OK => ">=",    -- absteigend
                                     GET     => GET_F,   -- GET fuer FARBE
                                     PUT     => PUT_F);  -- PUT fuer FARBE
   ------------------------------------------------------------------------
   R1 : REIH1(ROT..BLAU); -- Wird eingelesen, sortiert und ausgegeben
   R2 : REIH2(17..20);    -- Wird eingelesen, sortiert und ausgegeben
begin
   ada.text_io.put_line("Bitte geben Sie Ganzzahlen (0..99) ein:");
   REIH1_SEA.GET (ITEM => R1); -- Reihung R1 einlesen
   REIH1_SEA.SORT(R    => R1); -- Reihung R1 sortieren
   REIH1_SEA.PUT (ITEM => R1); -- Reihung R1 ausgeben
   ada.text_io.put_line("Bitte geben Sie ROT, GRUEN oder BLAU ein:");
   REIH2_SEA.GET (ITEM => R2); -- Reihung R2 einlesen
   REIH2_SEA.SORT(R    => R2); -- Reihung R2 sortieren
   REIH2_SEA.PUT (ITEM => R2); -- Reihung R2 ausgeben
end TESTS_15;