with ada.text_io;
procedure VERBE_01 is
---------------------------------------------------------------------------
-- Ein eingeschraenkter Verbunduntertyp LAST_WAGEN wird vereinbart. Daten
-- eines LAST_WAGEN-Verbundes werden eingelesen und wieder ausgegeben.
---------------------------------------------------------------------------
   type    ANZAHL   is        range 0..100_000;
   subtype ANZAHL_A is ANZAHL range 0..20;
   subtype STRING10 is string(1..10);
   -----------------------------------------------
   type LAST_WAGEN is record
      GEWICHT : ANZAHL   := 0;
      ACHSEN  : ANZAHL_A := 0;
      KENNZ   : STRING10 := "??????????";
      HAENGER : boolean  := false;
   end record;
   -----------------------------------------------
   LW1 :          LAST_WAGEN;
   LW2 :          LAST_WAGEN := (7_500, 2, "BRB-XY1234", false);
   LW3 : constant LAST_WAGEN := (KENNZ => "OHV-AB5678", ACHSEN => 3,
                                 GEWICHT => 25_000, HAENGER => true);
   ------------------------------------------------------------------------
   package ANZAHL_EA is new ada.text_io.integer_io    ( num => ANZAHL);
   package BOOL_EA   is new ada.text_io.enumeration_io(enum => boolean);
   ------------------------------------------------------------------------
   procedure GET(ITEM: out LAST_WAGEN) is
   -- Liest ITEM komponentenweise von der aktuellen Eingabe ein:
   begin
      ada.text_io.put_line("Bitte Daten fuer einen Lastwagen eingeben:");
      ada.text_io.put(item => "Gewicht (0..100_000)?           ");
      ANZAHL_EA  .get(item => ITEM.GEWICHT);
      ada.text_io.put(item => "Anzahl Achsen (0..20)?          ");
      ANZAHL_EA  .get(item => ITEM.ACHSEN);
      ada.text_io.put(item => "Kennzeichen (genau 10 Zeichen)? ");
      ada.text_io.get(item => ITEM.KENNZ);
      ada.text_io.put(item => "Haenger (true oder false)?      ");
      BOOL_EA    .get(item => ITEM.HAENGER);
   end GET;
   ------------------------------------------------------------------------
   procedure PUT(ITEM: LAST_WAGEN) is
   -- Gibt ITEM komponentenweise zur aktuellen Ausgabe aus:
   begin
      ada.text_io.put_line(item => "------------------------------------");
      ada.text_io.put_line(item => "Die Daten eines Lastwagens:");
      ada.text_io.put(item => "Gewicht:          ");
      ANZAHL_EA  .put(item => ITEM.GEWICHT);
      ada.text_io.new_line;
      ada.text_io.put(item => "Anzahl Achsen:    ");
      ANZAHL_EA  .put(item => ITEM.ACHSEN);
      ada.text_io.new_line;
      ada.text_io.put(item => "Kennzeichen:      ");
      ada.text_io.put(item => ITEM.KENNZ);
      ada.text_io.new_line;
      ada.text_io.put(item => "Haenger erlaubt?: ");
      BOOL_EA    .put(item => ITEM.HAENGER);
      ada.text_io.new_line;
   end PUT;
   ------------------------------------------------------------------------
begin
   LW1             :=  LW2;
   LW2             := (ACHSEN => 4, GEWICHT => 30_000, HAENGER => true,
                       KENNZ => "ABC-DE9876");
   LW1.ACHSEN      :=  5;
   LW2.GEWICHT     :=  LW3.ACHSEN * 10_000;
   LW2.KENNZ(5..6) := "YX";
   if LW1 = LW3 then
      null;
   end if;
   while LW2 /= LW3 loop
      LW2 := LW3;
   end loop;
   GET(ITEM => LW1);
   PUT(ITEM => LW1);
   PUT(ITEM => LW2);
   PUT(ITEM => LW3);
end VERBE_01;