with ada.text_io;
procedure VERBU_03 is
---------------------------------------------------------------------------
-- Ganzzahlen und Bruchzahlen werden zu einem varianten Verbundtyp ZAHL
-- zusammengefasst. Ein paar Variablen dieses Verbundtyps werden mani-
-- puliert. Ihre Werte werden zur aktuellen Ausgabe ausgegeben.
---------------------------------------------------------------------------
   type GANZ       is          range -1_000_000_000   .. +1_000_000_000;
   type GLEIT      is digits 5 range -1_000_000_000.0 .. +1_000_000_000.0;
   type ZAHLEN_ART is (GANZ_ZAHL, BRUCH_ZAHL);
   ------------------------------------------------------------------------
   type ZAHL(ART : ZAHLEN_ART := GANZ_ZAHL) is record
      case ART is
         when GANZ_ZAHL  =>
            GZ : GANZ   := 0;
         when BRUCH_ZAHL =>
            BZ : GLEIT  := 0.0;
      end case;
   end record;
   ------------------------------------------------------------------------
   Z1 : ZAHL(ART => GANZ_ZAHL ); -- Immer eine Ganzzahl
   Z2 : ZAHL(ART => BRUCH_ZAHL); -- Immer eine Bruchzahl
   Z3 : ZAHL;                    -- Anfangs Ganzzahl, aber aenderbar!
   ------------------------------------------------------------------------
   package  GANZ_EA is new ada.text_io.integer_io(num => GANZ);
   package GLEIT_EA is new ada.text_io.float_io  (num => GLEIT);
   ------------------------------------------------------------------------
   procedure PUT_LINE(ITEM : in ZAHL) is
   -- Gibt ITEM in lesbarer Form zur aktuellen Ausgabe aus und beginnt
   -- eine neue Zeile (mit ada.text_io.new_line)
   -- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
   begin  -- PUT_LINE
      case ITEM.ART is
         when GANZ_ZAHL  =>  GANZ_EA.put(item => ITEM.GZ, width => 0);
         when BRUCH_ZAHL => GLEIT_EA.put(item => ITEM.BZ, exp => 0);
      end case;
      ada.text_io.new_line;
   end PUT_LINE;
   ------------------------------------------------------------------------
begin -- VERBU_03
   Z1.GZ := 12345;                             PUT_LINE(ITEM => Z1);
   Z2.BZ := 5.4321;                            PUT_LINE(ITEM => Z2);
   Z3.GZ := 23456;                             PUT_LINE(ITEM => Z3);
   Z3    := (ART => BRUCH_ZAHL, BZ => 6.5432); PUT_LINE(ITEM => Z3);
   Z3    := (ART =>  GANZ_ZAHL, GZ => 79835);  PUT_LINE(ITEM => Z3);
end VERBU_03;